@call storage="snow.ks"
; Load the snow plug-in
@wait time=200

@eval exp="f.bg=''"
; Stores the currently loaded background

; Define macro changebg_and_clear
@macro name="changebg_and_clear"
@if exp="mp.storage != f.bg"
; If it's the same as the currently loaded background, don't execute the change
@eval exp="f.bg = mp.storage"
@backlay
@layopt layer=message0 page=back visible=false
@trans method=crossfade time=300
@wt
@image * layer=base page=back
@trans method=crossfade time=300
@wt
@cm
@layopt layer=message0 page=back visible=true
@trans method=crossfade time=300
@wt
@endif
@endmacro

; Define macro loadbg
@macro name="loadbg"
@image * layer=base
@eval exp="f.bg = mp.storage"
@endmacro

; Define macro start_select
@macro name="start_select"
@backlay
@nowait
@history output=false
@current page=back
@endmacro

; Define macro end_select
@macro name="end_select"
@trans method=crossfade time=400
@wt
@endnowait
@history output=true
@current page=fore
@endmacro

; Define macro i
@macro name="i"
@font italic=true
@endmacro

; Define macro /i
@macro name="/i"
@font italic=false
@endmacro



*syokai_start|Introduction to KiriKiri and KAG - Menu
@startanchor

; Load the background image, draw the menu on the message layer
@backlay
@loadbg storage="_24_5" page=back
@current page=back
@cm
@layopt layer=message0 page=back visible=true
@nowait
@history output=false
@style align=center
[font size=40 color=0x00ffff]Introduction to KiriKiri and KAG[resetfont][r]
[r]
[link target="*about_kirikiri"]What is KiriKiri?[endlink][r]
[link target="*about_kag"]What is KAG?[endlink][r]
[r]
[r]
[r]
[r]
[r]
[r]
[r]
[link exp="kag.shutdown()" color=0xff0000 hint="Exit the Introduction to KiriKiri/KAG"]Exit[endlink]
@endnowait
@history output=true
@current page=fore

; Message layer transition
@trans method=crossfade time=800
@wt

; History recording
@record

; Wait until a selection is made
@s

*to_syokai_start
; return to syokai_start
@backlay
@layopt layer=message0 page=back visible=false
@trans method=crossfade time=300
@wt
@jump target=*syokai_start


*about_kirikiri|What is KiriKiri?
@changebg_and_clear storage="_24_4"
KiriKiri is software created in the TJS scripting language to perform various tasks.[l][r]
The TJS language is like a cross between Java and Javascript, and relatively easy to learn compared to C or C++.[l][r]
Using KiriKiri, the main program is controlled by TJS scripts in order to create various applications.[l][r]
It has particularly strong multimedia capabilities and is suitable for 2D games with relatively static displays.[p]
*about_kirikiri2|
@cm
KiriKiri composes its picture using numerous images called layers overlapping each other.[l]  Layers can be overlayed using an alpha blend and can take on an heirarchical structure.[l][r]
By default, layers can be loaded from PNG/JPEG/ERI/BMP files; the Susie plugin can extend this to include even more file formats.[l][r]
The drawing system can't draw anything too complex, but it can render partially transparent rectangles and and antialiased text, as well as resize or transform images.[l][r]
Using AVI/MPEG or SWF (Macromedia Flash) files, it can play movies.[p]
*about_kirikiri3|
@cm
KiriKiri can play CD-DA, MIDI sequences, or PCM audio, adjusting the various volume levels.[l]  For PCM audio, it can play uncompressed .wav files; this can be extended to other formats as well using plugins, such as OggVorbis playback.[l][r]
Several PCM sounds can be played at the same time.[l]  If you force it to, it can even play multiple CD-DA or MIDI sequences at the same time.[p]
*about_kirikiri4
@cm
Other supplimentary tools are included:  
[font color=0xffff00]Releaser[resetfont] can combine several files into one, or create a stand-alone self-executing file,[l] 
[font color=0xffff00]KiriKiri Settings[resetfont] can adjust the various options for the KiriKiri main program,[l] 
the [font color=0xffff00]Pre-rendered Font Creation Tool[resetfont] can be used to prepare fonts on the developer side, so they're usable even if the font isn't installed on the player's side,[l] 
and the [font color=0xffff00]Transparent Image Format Converter[resetfont] can be used to convert images with transparency data between various image formats.[l] 
[r]
[r]
@start_select
[link target=*to_syokai_start]Return to the menu[endlink]
@end_select
[s]

*about_kag|What is KAG?
@changebg_and_clear storage="_24_4"
KAG is a kit designed to create visual novel or sound novel-style games, or story-driven, choice-based text adventure games.[l][r]
KAG is a script that is executed by the KiriKiri game engine, itself written using TJS script.[l]  The scripts used by KAG are called "scenarios," and are again different from TJS scripts.[l]  TJS scripts require a rather heavy understanding of programming, but scenarios can be written more easily.[l][r]
KAG is a system created on top of KiriKiri, so most of the functionality in KiriKiri can be used in KAG.[p]
*about_kag3|
@cm
Text display in KAG, as you can see, includes antialiased text,[l][r]
displaying [font size=60]large text[resetfont],[l][r]
p[ruby text="also"]ronu[ruby text="known"]ncia[ruby text="as"]tion[ruby text="''ruby''"] gui[ruby text="text"]des, [l][font shadow=false edge=true edgecolor=0xff0000]outlined text[resetfont],[l][r]
[style align=center]center-aligned text,[r]
[style align=right]right-aligned text,[r][resetstyle]
[l]
in-line special characters like this [graph storage="ExQuestion.png" alt="!?"],[l][r]
and various other capabilities.[p]
*about_kag4|
@position vertical=true
Also, it can display text vertically.[l][r]
You can use exactly the same features when using vertical text.[p]
@layopt layer=message0 visible=false
@layopt layer=message1 visible=true
@current layer=message1
@position frame=messageframe left=20 top=280 marginl=16 margint=16 marginr=0 marginb=16 draggable=true vertical=false
Messages can be displayed inside a message frame like this.[l]  This type is often used in adventure games.[p]
@layopt layer=message1 visible=false
@layopt layer=message0 visible=true
@current layer=message0
@position vertical=false
*about_kag5|
@cm
Character portraits can be used like this (sorry it's a [i]sea urchin[/i] as always) 
@backlay
@image storage=uni page=back layer=0 visible=true opacity=255
@trans method=crossfade time=1000
@wt
overlayed using an alpha blend.[l][r]
Like this, 
@backlay
@layopt page=back layer=0 opacity=128
@trans method=crossfade time=1000
@wt
it can be displayed very faintly.[l][r]
By default up to three images can be overlayed.[p]
@backlay
@layopt page=back layer=0 visible=false
@trans method=crossfade time=300
@wt
*about_kag6|
@cm
By defualt there are three kinds of transitions (screen changes).[l][r]
One of these is the simple cross fade, [l]
@backlay
@layopt page=back layer=message0 visible=false
@trans method=crossfade time=300
@wt
@backlay
@image storage="_24" page=back layer=base
@trans method=crossfade time=3000
@wt
@backlay
@image storage="_24_4" page=back layer=base
@trans method=crossfade time=3000
@wt
@backlay
@layopt page=back layer=message0 visible=true
@trans method=crossfade time=300
@wt
[l][r]
Another is the scroll transition, which produces a sliding effect, [l]
@backlay
@layopt page=back layer=message0 visible=false
@trans method=crossfade time=300
@wt
@backlay
@image storage="_24" page=back layer=base
@trans method=scroll from=right stay=stayfore time=3000
@wt
@backlay
@image storage="_24_4" page=back layer=base
@trans method=scroll from=bottom stay=nostay time=3000
@wt
@backlay
@layopt page=back layer=message0 visible=true
@trans method=crossfade time=300
@wt
[l][r]
and the final is the universal translation, which allows creators to freely make patterns.[l][r]
Universal transitions use grayscale images called "transition rules" that transition sooner on the darker parts of the image.[l][r]
For instance, [l]
@image layer=base page=fore storage="trans1"
If you use a rule image like this...[l]
@backlay
@layopt page=back layer=message0 visible=false
@image storage="_24_4" page=back layer=base
@trans method=crossfade time=300
@wt
@backlay
@image storage="_24" page=back layer=base
@trans method=universal rule="trans1" vague=64 time=3000
@wt
@backlay
@image storage="_24_4" page=back layer=base
@trans method=universal rule="trans1" vague=64 time=3000
@wt
@backlay
@layopt page=back layer=message0 visible=true
@trans method=crossfade time=300
@wt
[r]
For instance, [l]
@image layer=base page=fore storage="nami"
If you use a rule image like this...[l]
@backlay
@layopt page=back layer=message0 visible=false
@image storage="_24_4" page=back layer=base
@trans method=crossfade time=300
@wt
@backlay
@image storage="_24" page=back layer=base
@trans method=universal rule="nami" vague=64 time=3000
@wt
@backlay
@image storage="_24_4" page=back layer=base
@trans method=universal rule="nami" vague=64 time=3000
@wt
@backlay
@layopt page=back layer=message0 visible=true
@trans method=crossfade time=300
@wt
[r]
And like that, various kinds can be created.[p]
*about_kag7|What is KAG?
@cm
For background music, either CD-DA, MIDI, or PCM can be used.[l]  Sound effects can use PCM.[l]  All of these can use features such as fading and volume control.[l][r]
By default, KAG can play uncompressed .wav files for PCM audio.[l]  Plugins can also be used to extend playable formats so it can play OggVorbis files.[l][r]
KAG can play AVI/MPEG/SWF movie files.[p]
*about_kag8|
@cm
KAG variables can store strings as well as numbers.  It can handle an unlimited number of variables, handle strings of unlimited length; and it deal with not only integers, but floating-point values as well.[l]  Rather than properties of KAG variables, these are properties of TJS variables, which KAG is based on.[l][r]
Within variables there are two types: game variables and system variables.  Game variables are saved and loaded along with bookmark data, but system variables can continuously store the same contents regardless of bookmark data.[l][r]
Here's an example of using variables...[p]
@eval exp="f.v1 = intrandom(1, 9)"
@eval exp="f.v2 = intrandom(1, 9)"
@eval exp="f.ans = f.v1 * f.v2"
@eval exp="f.input = ''"
*about_kag_var_0|Math problem
@cm
Here's a math problem.  What is [emb exp="f.v1"] ~ [emb exp="f.v2"]?[r]
[font size=20](After inputting your answer, click "OK".)[resetfont][r]
[r]
@start_select
@[edit name="f.input" length=200 opacity=80 bgcolor=0x000000 color=0xffffff] [link target=*about_kag_var_1]      OK      [endlink][r]
[r]
@[link target=*about_kag_9]It's a pain, so I'll skip it[endlink]
@end_select
@eval exp="kag.fore.messages[0].links[0].object.focus()"
; set focus to the input field
; Set history logging in case they choose "System -> go back" to return to this point
@record
[s]

*about_kag_var_1
@commit
@jump cond="str2num(f.input) == f.ans" target=*about_kag_var_correct
@cm
Incorrect![l][r]
Please input it again.[p]
@jump target=*about_kag_var_0

*about_kag_var_correct
@cm
Correct![p]
@jump target=*about_kag_9

*about_kag_9|
@cm
@snowinit forevisible=true backvisible=false
An important characteristic of KAG is its extensibility and customizability.[l]  Even if you can't do something with just KAG, by using TJS to directly control KiriKiri, many things are possible.[l][r]
For instance, by loading a plugin for KAG to display "snow," you can make it snow like this.[l]  There are also plugins that increase the types of transitions available.[l][r]
Also, because KAG itself is written as a TJS script, by editing the script files, you can customize the way every last nook and cranny of the the program runs.[p]
@backlay
@snowopt backvisible=false
@trans method=crossfade time=1000
@wt
@snowuninit
*about_kag_fin|End of the KAG introduction
@cm
This concludes the introduction to KAG.[l][r]
By all means, everybody please use KiriKiri/KAG to make more wonderful games.[l][r]
[r]
@start_select
[link exp="System.shellExecute('http://www.mysteryparfait.com/kage-kirie/')" hint="Open the Kage-Kirie website"]Kage-Kirie website (English)[endlink][r]
[link exp="System.shellExecute('http://kikyou.info/tvp/')" hint="Open the KiriKiri/KAG download page"]KiriKiri download page (Japanese)[endlink][r]
[r]
[link target=*to_syokai_start]Return to the menu[endlink]
@end_select
[s]
