//---------------------------------------------------------------------------
/*
	Risa [肳]      alias gg3 [kirikiri-3]
	 stands for "Risa Is a Stagecraft Architecture"
	Copyright (C) 2000-2008 W.Dee <dee@kikyou.info> and contributors

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------
//! @file
//! @brief Phase Vocoder ̎
//---------------------------------------------------------------------------
#ifndef RisaPhaseVocoderH
#define RisaPhaseVocoderH

#include "RingBuffer.h"

//---------------------------------------------------------------------------
//! @brief Phase Vocoder DSP NX
//---------------------------------------------------------------------------
class tRisaPhaseVocoderDSP
{
protected:
	float ** AnalWork; //!< (Analyze)pobt@(FrameSize) Oŏ΂Ȃ悤
	float ** SynthWork; //!< pƃobt@(FrameSize)
	float ** LastAnalPhase; //!< O͎̊etB^oḧʑ (e`lƂFrameSize/2)
	float ** LastSynthPhase; //!< O񍇐̊etB^oḧʑ (e`lƂFrameSize/2)

	int * FFTWorkIp; //!< rdft ɓn ip p[^
	float * FFTWorkW; //!< rdft ɓn w p[^
	float * InputWindow; //!< ͗p֐
	float * OutputWindow; //!< o͗p֐

	unsigned int FrameSize; //!< FFTTCY
	unsigned int OverSampling; //!< I[o[ETvOW
	unsigned int Frequency; //!< PCM TvOg
	unsigned int Channels; //!< PCM `l
	unsigned int InputHopSize; //!< FrameSize/OverSampling
	unsigned int OutputHopSize; //!< InputHopSize * TimeScale (SetTimeScaleɍČvZ)

	float	TimeScale; //!< Ԏ̃XP[(o/)
	float	FrequencyScale; //!< g̃XP[(o/)

	// ȉARebuildParams ^̎ɍč\zp[^
	// ɂ郁oȊOł́AInputWindow  OutputWindow č\z
	float OverSamplingRadian; //!< (2.0*M_PI)/OverSampling
	float OverSamplingRadianRecp; //!< OverSamplingRadian ̋t
	float FrequencyPerFilterBand; //!< Frequency/FrameSize
	float FrequencyPerFilterBandRecp; //!< FrequencyPerFilterBand ̋t
	float ExactTimeScale; //!< TimeScale = OutputHopSize / InputHopSize
	// č\zp[^A܂

	tRisaRingBuffer<float> InputBuffer; //!< ͗pOobt@
	tRisaRingBuffer<float> OutputBuffer; //!< o͗pOobt@

	bool	RebuildParams; //!< Iȃp[^Ȃǂč\zȂ΂ȂȂƂɐ^

	unsigned long LastSynthPhaseAdjustCounter; //!< LastSynthPhase ␳͂邽߂̃JE^
	const static unsigned long LastSynthPhaseAdjustIncrement = 0x03e8a444; //!< LastSynthPhaseAdjustCounterɉZl
	const static unsigned long LastSynthPhaseAdjustInterval  = 0xfa2911fe; //!< LastSynthPhase ␳


public:
	//! @brief Process ԂXe[^X
	enum tStatus
	{
		psNoError, //!< Ȃ
		psInputNotEnough, //!< ͂Ȃ (GetInputBufferœ|C^ɏĂĎs)
		psOutputFull //!< o̓obt@ς (GetOutputBufferœ|C^ǂݏoĂĎs)
	};

public:
	//! @brief		RXgN^
	//! @param		framesize		t[TCY(2̗ݏ, 16`)
	//! @param		frequency		PCM̃TvO[g
	//! @param		channels		PCM̃`l
	//! @note		ypłframesize=4096,oversamp=16炢悭A
	//! @note		{CXpłframesize=256,oversamp=8炢悢B
	tRisaPhaseVocoderDSP(unsigned int framesize,
					unsigned int frequency, unsigned int channels);

	//! @brief		fXgN^
	~tRisaPhaseVocoderDSP();

	float GetTimeScale() const { return TimeScale; } //!< Ԏ̃XP[𓾂

	//! @brief		Ԏ̃XP[ݒ肷
	//! @param		v     XP[
	void SetTimeScale(float v);

	float GetFrequencyScale() const { return FrequencyScale; } //!< g̃XP[𓾂

	//! @brief		g̃XP[ݒ肷
	//! @param		v     XP[
	void SetFrequencyScale(float v);

	//! @brief		I[o[TvOW擾
	//! @return		I[o[TvOW
	unsigned int GetOverSampling() const { return OverSampling; }

	//! @brief		I[o[TvOWݒ肷
	//! @param		v		W ( 0 = Ԏ̃XP[ɏ]ĎIɐݒ )
	void SetOverSampling(unsigned int v);

	unsigned int GetInputHopSize() const { return InputHopSize; } //!< InputHopSize𓾂
	unsigned int GetOutputHopSize() const { return OutputHopSize; } //!< OutputHopSize 𓾂

private:
	//! @brief		NA
	void Clear();

public:
	//! @brief		̓obt@̋󂫃TvOj[𓾂
	//! @return		̓obt@̋󂫃TvOj[
	size_t GetInputFreeSize();

	//! @brief		̓obt@̏݃|C^𓾂
	//! @param		numsamplegranules ݂TvOj[
	//! @param		p1		ubN1̐擪ւ̃|C^i[邽߂̕ϐ
	//! @param		p1size	p1̕\ubÑTvOj[
	//! @param		p2		ubN2̐擪ւ̃|C^i[邽߂̕ϐ(NULL蓾)
	//! @param		p2size	p2̕\ubÑTvOj[(0蓾)
	//! @return		󂫗eʂȂ΋UA󂫗eʂA|C^Ԃΐ^
	//! @note		p1  p2 ̂悤ɂQ̃|C^Ƃ̃TCYԂ̂́A
	//!				̃obt@ۂ̓Oobt@ŁAOobt@̃jAȃobt@
	//!				̏I[܂\邽߁B܂Ȃꍇp2NULLɂȂ邪A܂
	//!				ꍇ p1 ̂Ƃ p2 ɑď܂Ȃ΂ȂȂB
	bool GetInputBuffer(size_t numsamplegranules,
		float * & p1, size_t & p1size,
		float * & p2, size_t & p2size);

	//! @brief		o̓obt@̏ς݃TvOj[𓾂
	//! @return		o̓obt@̏ς݃TvOj[
	size_t GetOutputReadySize();

	//! @brief		o̓obt@̓ǂݍ݃|C^𓾂
	//! @param		numsamplegranules ǂݍ݂TvOj[
	//! @param		p1		ubN1̐擪ւ̃|C^i[邽߂̕ϐ
	//! @param		p1size	p1̕\ubÑTvOj[
	//! @param		p2		ubN2̐擪ւ̃|C^i[邽߂̕ϐ(NULL蓾)
	//! @param		p2size	p2̕\ubÑTvOj[(0蓾)
	//! @return		ꂽTvȂ΋UATvA|C^Ԃΐ^
	//! @note		p1  p2 ̂悤ɂQ̃|C^Ƃ̃TCYԂ̂́A
	//!				̃obt@ۂ̓Oobt@ŁAOobt@̃jAȃobt@
	//!				̏I[܂\邽߁B܂Ȃꍇp2NULLɂȂ邪A܂
	//!				ꍇ p1 ̂Ƃ p2 𑱂ēǂݏoȂ΂ȂȂB
	bool GetOutputBuffer(size_t numsamplegranules,
		const float * & p1, size_t & p1size,
		const float * & p2, size_t & p2size);

	//! @brief		1Xebvs
	//! @return		ʂ\enum
	tStatus Process();

	//! @brief		Z̍
	//! @param		ch			s`l
	//! @note		͊̕eCPUƂɍœK邽߁A
	//!				 opt_default fBNgȂǂɒuB
	//!				(PhaseVocoderDSP.cppɂ͂̎͂Ȃ)
	void ProcessCore(int ch);
};
//---------------------------------------------------------------------------

#endif
