/****************************************************************************/
/*! @file
@brief VMR9gI[o[CNX

sɂDirectX9ȍ~Kv
-----------------------------------------------------------------------------
	Copyright (C) 2005 T.Imoto
-----------------------------------------------------------------------------
@author		T.Imoto
@date		2005/09/25
@note
			2005/09/25	T.Imoto		쐬
*****************************************************************************/


//#define _WIN32_WINNT 0x0400
//#define _WIN32_DCOM			// DCOM

#include "dsmixer.h"
#include "CIStream.h"
#include "DShowException.h"
#include "OptionInfo.h"
#include <dvdmedia.h>
#include <windowsx.h>
#include <objbase.h>
#include "CVMRCustomAllocatorPresenter9.h"

//----------------------------------------------------------------------------
//! @brief	  	
//----------------------------------------------------------------------------
tTVPDSMixerVideoOverlay::tTVPDSMixerVideoOverlay()
{
	m_AvgTimePerFrame = 0;
	m_OwnerInst = 0;
	m_Width = 0;
	m_Height = 0;
	m_AllocatorPresenter = NULL;
	m_hMessageDrainWnd = NULL;
}
//----------------------------------------------------------------------------
//! @brief	  	C^[tFCX
//----------------------------------------------------------------------------
tTVPDSMixerVideoOverlay::~tTVPDSMixerVideoOverlay()
{
	Shutdown = true;
	ReleaseAll();
	m_hMessageDrainWnd = NULL;
}
//----------------------------------------------------------------------------
//! @brief	  	C^[tFCX
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::ReleaseAll()
{
	if( m_MediaControl.p != NULL )
	{
		m_MediaControl->Stop();
	}

	if( m_AllocatorPresenter != NULL )
	{
//		delete m_AllocatorPresenter;
		m_AllocatorPresenter->Release();
		m_AllocatorPresenter = NULL;
	}

	if( m_VMR9SurfAllocNotify.p )
		m_VMR9SurfAllocNotify.Release();

	if( m_VMR9MixerCtrl.p )
		m_VMR9MixerCtrl.Release();

	if( m_VMR9MixerBmp.p )
		m_VMR9MixerBmp.Release();

//	if( m_VMR9WinLessCtrl.p )
//		m_VMR9WinLessCtrl.Release();

	tTVPDSMovie::ReleaseAll();
}
//----------------------------------------------------------------------------
//! @brief	  	tB^Ot̍\z
//! @param 		callbackwin : bZ[W𑗐MEBhE
//! @param 		stream : ǂݍ݌Xg[
//! @param 		streamname : Xg[̖O
//! @param 		type : fBA^Cv(gq)
//! @param 		size : fBATCY
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::BuildGraph( HWND callbackwin, IStream *stream, const wchar_t * streamname, const wchar_t *type, unsigned __int64 size )
{
	HRESULT			hr;

	//CoInitialize(NULL);

	// detect CMediaType from stream's extension ('type')
	try {
		if( FAILED(hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED)) )
			ThrowDShowException(L"Failed to call CoInitializeEx.", hr);

		// create IFilterGraph instance
		if( FAILED(hr = m_GraphBuilder.CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC)) )
			ThrowDShowException(L"Failed to create FilterGraph.", hr);

		// Register to ROT
		if(GetShouldRegisterToROT())
		{
			AddToROT(m_dwROTReg);
		}

		{
			CAutoLock Lock(&m_VMRLock);
			OwnerWindow = callbackwin;	// copy window handle for D3D
			m_OwnerInst = GetModuleHandle(NULL);
		}
		m_AllocatorPresenter = new CVMRCustomAllocatorPresenter9(this,m_VMRLock);
		m_AllocatorPresenter->AddRef();
		m_AllocatorPresenter->Initialize();
		if( IsWindowsMediaFile(type) )
		{
			CComPtr<IBaseFilter>	pVMR9;
			AddVMR9Filer( pVMR9 );
			BuildWMVGraph( pVMR9, stream );

			if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerCtrl ) ) )
				ThrowDShowException(L"Failed to query IVMRMixerControl9.", hr);
			if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerBmp ) ) )
				ThrowDShowException(L"Failed to query IVMRMixerBitmap9.", hr);
		}
		else
		{
			CMediaType mt;
			mt.majortype = MEDIATYPE_Stream;
			ParseVideoType( mt, type ); // may throw an exception

			// create proxy filter
			m_Proxy = new CIStreamProxy( stream, size );
			hr = S_OK;
			m_Reader = new CIStreamReader( m_Proxy, &mt, &hr );
			if( FAILED(hr) || m_Reader == NULL )
				ThrowDShowException(L"Failed to create proxy filter object.", hr);
			m_Reader->AddRef();

			// add fliter
			if( FAILED(hr = GraphBuilder()->AddFilter( m_Reader, L"Stream Reader")) )
				ThrowDShowException(L"Failed to call IFilterGraph::AddFilter.", hr);
	
			// AddFilter̂Release
			m_Reader->Release();

			if( mt.subtype == MEDIASUBTYPE_Avi || mt.subtype == MEDIASUBTYPE_QTMovie )
			{
				// render output pin
				if( FAILED(hr = GraphBuilder()->Render(m_Reader->GetPin(0))) )
					ThrowDShowException(L"Failed to call IGraphBuilder::Render.", hr);
	
				CComPtr<IBaseFilter>	pRender;
				if( FAILED(hr = FindVideoRenderer( &pRender ) ) )
					ThrowDShowException(L"Failed to call FindVideoRenderer( &pRender ).", hr);
	
				CComPtr<IPin>	pRenderPin;
				pRenderPin = GetInPin(pRender, 0);
	
				// get decoder output pin
				CComPtr<IPin>			pDecoderPinOut;
				if( FAILED(hr = pRenderPin->ConnectedTo( &pDecoderPinOut )) )
					ThrowDShowException(L"Failed to call pRenderPin->ConnectedTo( &pDecoderPinOut ).", hr);
	
				// dissconnect pins
				if( FAILED(hr = pDecoderPinOut->Disconnect()) )
					ThrowDShowException(L"Failed to call pDecoderPinOut->Disconnect().", hr);
				if( FAILED(hr = pRenderPin->Disconnect()) )
					ThrowDShowException(L"Failed to call pRenderPin->Disconnect().", hr);
	
				// remove default render
				if( FAILED(hr = GraphBuilder()->RemoveFilter( pRender ) ) )
					ThrowDShowException(L"Failed to call GraphBuilder->RemoveFilter(pRenderPin).", hr);

				CComPtr<IBaseFilter>	pVMR9;
				AddVMR9Filer( pVMR9 );
	
				CComPtr<IPin>	pRdrPinIn;
				pRdrPinIn = GetInPin(pVMR9, 0);
	
				if( FAILED(hr = GraphBuilder()->ConnectDirect( pDecoderPinOut, pRdrPinIn, NULL )) )
					ThrowDShowException(L"Failed to call GraphBuilder()->ConnectDirect( pDecoderPinOut, pRdrPinIn, NULL ).", hr);
	
				if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerCtrl ) ) )
					ThrowDShowException(L"Failed to query IVMRMixerControl9.", hr);
				if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerBmp ) ) )
					ThrowDShowException(L"Failed to query IVMRMixerBitmap9.", hr);
			}
			else
			{
				CComPtr<IBaseFilter>	pVMR9;
				AddVMR9Filer( pVMR9 );
				BuildMPEGGraph( pVMR9, m_Reader); // may throw an exception
	
				if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerCtrl ) ) )
					ThrowDShowException(L"Failed to query IVMRMixerControl9.", hr);
				if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9MixerBmp ) ) )
					ThrowDShowException(L"Failed to query IVMRMixerBitmap9.", hr);
			}
		}
#if 1
		{	// σt[\Ԃ擾
			CComPtr<IBaseFilter>	pRender;
			if( FAILED(hr = FindVideoRenderer( &pRender ) ) )
				ThrowDShowException(L"Failed to call FindVideoRenderer( &pRender ).", hr);

			CComPtr<IPin>	pRenderPin;
			pRenderPin = GetInPin(pRender, 0);

			AM_MEDIA_TYPE mt;
			if( FAILED(hr = pRenderPin->ConnectionMediaType(&mt)) )
				ThrowDShowException(L"Failed to call IPin::ConnectionMediaType(pmt).", hr);
			if( mt.formattype == FORMAT_VideoInfo && mt.cbFormat != 0 )
			{
				VIDEOINFOHEADER	*vih = reinterpret_cast<VIDEOINFOHEADER*>(mt.pbFormat);
				m_AvgTimePerFrame = vih->AvgTimePerFrame;
				m_Width = vih->bmiHeader.biWidth;
				m_Height = vih->bmiHeader.biHeight;
			}
			else if( mt.formattype == FORMAT_VideoInfo2 && mt.cbFormat != 0 )
			{
				VIDEOINFOHEADER2 *vih = reinterpret_cast<VIDEOINFOHEADER2*>(mt.pbFormat);
				m_AvgTimePerFrame = vih->AvgTimePerFrame;
				m_Width = vih->bmiHeader.biWidth;
				m_Height = vih->bmiHeader.biHeight;
			}
			FreeMediaType(mt);
		}
#endif
		// query each interfaces
		if( FAILED(hr = m_GraphBuilder.QueryInterface( &m_MediaControl )) )
			ThrowDShowException(L"Failed to query IMediaControl", hr);
		if( FAILED(hr = m_GraphBuilder.QueryInterface( &m_MediaPosition )) )
			ThrowDShowException(L"Failed to query IMediaPosition", hr);
		if( FAILED(hr = m_GraphBuilder.QueryInterface( &m_MediaSeeking )) )
			ThrowDShowException(L"Failed to query IMediaSeeking", hr);
		if( FAILED(hr = m_GraphBuilder.QueryInterface( &m_MediaEventEx )) )
			ThrowDShowException(L"Failed to query IMediaEventEx", hr);

		if( FAILED(hr = m_GraphBuilder.QueryInterface( &m_BasicAudio )) )
			ThrowDShowException(L"Failed to query IBasicAudio", hr);

		// set notify event
		if(callbackwin)
		{
			if(FAILED(hr = Event()->SetNotifyWindow((OAHWND)callbackwin, WM_GRAPHNOTIFY, (long)(this))))
				ThrowDShowException(L"Failed to set IMediaEventEx::SetNotifyWindow.", hr);
		}
	}
	catch(const wchar_t *msg)
	{
		MakeAPause(true);
		ReleaseAll();
		CoUninitialize();
		TVPThrowExceptionMessage(msg);
	}
	catch(...)
	{
		MakeAPause(true);
		ReleaseAll();
		CoUninitialize();
		throw;
	}

	MakeAPause(false);
	CoUninitialize();
}
//----------------------------------------------------------------------------
//! @brief	  	VMR9tB^tB^Ot֒ǉ
//! @param 		pVMR9 : VMR9tB^
//----------------------------------------------------------------------------
void tTVPDSMixerVideoOverlay::AddVMR9Filer( CComPtr<IBaseFilter> &pVMR9 )
{
	HRESULT			hr = S_OK;
	if( FAILED(hr = pVMR9.CoCreateInstance(CLSID_VideoMixingRenderer9, NULL, CLSCTX_INPROC) ) )
		ThrowDShowException(L"Failed to create VMR9 Filter. This component requires DirectX9.", hr);

	if( FAILED(hr = GraphBuilder()->AddFilter( pVMR9, L"Video Mixing Render 9")) )
		ThrowDShowException(L"Failed to call GraphBuilder()->AddFilter( pVMR9, L\"Video Mixing Render 9\").", hr);

	{
		CComPtr<IVMRFilterConfig9>	pConfig;
		if( FAILED(hr = pVMR9.QueryInterface(&pConfig) ) )
			ThrowDShowException(L"Failed to query IVMRFilterConfig9.", hr);

		if( FAILED(hr = pConfig->SetNumberOfStreams(1) ) )
			ThrowDShowException(L"Failed to call IVMRFilterConfig9::SetNumberOfStreams(1).", hr);
		if( FAILED(hr = pConfig->SetRenderingMode(VMR9Mode_Renderless ) ) )
			ThrowDShowException(L"Failed to call IVMRFilterConfig9::SetRenderingMode(VMR9Mode_Renderless).", hr);

		// Negotiate Renderless mode
		if( FAILED(hr = pVMR9.QueryInterface( &m_VMR9SurfAllocNotify ) ) )
			ThrowDShowException(L"Failed to query IVMRSurfaceAllocatorNotify9.", hr);

		CComPtr<IVMRSurfaceAllocator9>	alloc;
		if( FAILED(hr = AllocatorPresenter()->QueryInterface( IID_IVMRSurfaceAllocator9, reinterpret_cast<void**>(&alloc.p) ) ) )
			ThrowDShowException(L"Failed to query IVMRSurfaceAllocator9.", hr);
		if( FAILED(hr = AllocatorNotify()->AdviseSurfaceAllocator( reinterpret_cast<DWORD_PTR>(this), alloc ) ) )
			ThrowDShowException(L"Failed to call IVMRSurfaceAllocatorNotify9::AdviseSurfaceAllocator().", hr);
		if( FAILED(hr = Allocator()->AdviseNotify( AllocatorNotify() ) ) )
			ThrowDShowException(L"Failed to call IVMRSurfaceAllocator9::AdviseNotify().", hr);

		// query monitor config
//		if( FAILED(hr = pVMR9.QueryInterface(&m_VMR9MonitorConfig)) )
//			ThrowDShowException(L"Failed to query IVMRMonitorConfig9.", hr);
	}
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOrbg}bvݒ肷
//! @param 		hdc : ݒ肵Ărbg}bvێĂfoCXReLXg
//! @param 		dest : ]ʒu
//! @param 		alpha : At@l (0.0 - 1.0Ŏw)
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetMixingBitmap( HDC hdc, RECT *dest, float alpha )
{
	HRESULT			hr;
	VMR9AlphaBitmap	bmpInfo;
	ZeroMemory(&bmpInfo, sizeof(bmpInfo));
	bmpInfo.dwFlags = VMR9AlphaBitmap_hDC | VMR9AlphaBitmap_FilterMode;
	bmpInfo.hdc = hdc;

	bmpInfo.rSrc.left = 0;
	bmpInfo.rSrc.top = 0;
	bmpInfo.rSrc.right = dest->right - dest->left;
	bmpInfo.rSrc.bottom = dest->bottom - dest->top;

	long width;
	long height;
//	GetVideoSize( &width, &height );
	// rfITCYł͂ȂAŏIo͉摜̃TCYňʒuvZ
	width = Rect.right - Rect.left;
	height = Rect.bottom - Rect.top;
	// 0
	if( width <= 0 ) width = 1;
	if( height <= 0 ) height = 1;
	if( dest )
	{
		bmpInfo.rDest.left = (static_cast<float>(dest->left)+0.5f)/static_cast<float>(width);
		bmpInfo.rDest.top = (static_cast<float>(dest->top)+0.5f)/static_cast<float>(height);
		bmpInfo.rDest.right = (static_cast<float>(dest->right)+0.5f)/static_cast<float>(width);
		bmpInfo.rDest.bottom = (static_cast<float>(dest->bottom)+0.5f)/static_cast<float>(height);
	}
	else
	{	// NULL̎́AŜɃuh悤ɂ
		bmpInfo.rDest.left = 0.0f;
		bmpInfo.rDest.top = 0.0f;
		bmpInfo.rDest.right = 1.0f;
		bmpInfo.rDest.bottom = 1.0f;
	}
	bmpInfo.fAlpha = alpha;
	bmpInfo.dwFilterMode = MixerPref_PointFiltering;

	if(FAILED(hr = MixerBmp()->SetAlphaBitmap( &bmpInfo )) )
		ThrowDShowException(L"Failed to set IVMRMixerBitmap9::SetAlphaBitmap.", hr);
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOĂrbg}bv̐ݒ
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::ResetMixingBitmap()
{
	HRESULT			hr;
	VMR9AlphaBitmap	bmpInfo;
	if(FAILED(hr = m_VMR9MixerBmp->GetAlphaBitmapParameters(&bmpInfo)) )
		ThrowDShowException(L"Failed to set IVMRMixerBitmap9::GetAlphaBitmapParameters.", hr);

	if( bmpInfo.hdc == NULL )	// ݒ肳ĂȂ̂Ń^[
		return;

	ZeroMemory(&bmpInfo, sizeof(bmpInfo));

	// ݒ肹ɂ̃\bhR[ƁArbg}bvƂdl炵B
	if(FAILED(hr = MixerBmp()->UpdateAlphaBitmapParameters( &bmpInfo )) )
		ThrowDShowException(L"Failed to set IVMRMixerBitmap9::UpdateAlphaBitmapParameters.", hr);
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOrfIXg[̃At@lݒ肷
//! @param		a : ݒ肷At@l
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetMixingMovieAlpha( float a )
{
	HRESULT			hr;
	if(FAILED(hr = MixerControl()->SetAlpha( 0, a )) )
		ThrowDShowException(L"Failed to set IVMRMixerControl9::SetAlpha.", hr);
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOrfIXg[̃At@l擾
//! @param		a : At@l󂯎|C^
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::GetMixingMovieAlpha( float *a )
{
	HRESULT			hr;
	if(FAILED(hr = MixerControl()->GetAlpha( 0, a )) )
		ThrowDShowException(L"Failed to set IVMRMixerControl9::GetAlpha.", hr);
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOrfIXg[̔wiFݒ肷
//! @param		col : ݒ肷wiF
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetMixingMovieBGColor( unsigned long col )
{
	HRESULT			hr;
	COLORREF	cr = ChangeEndian32(col<<8);
	if(FAILED(hr = MixerControl()->SetBackgroundClr( cr )) )
		ThrowDShowException(L"Failed to set IVMRMixerControl9::SetBackgroundClr.", hr);
}
//----------------------------------------------------------------------------
//! @brief	  	~LVOrfIXg[̔wiF擾
//! @param		col : wiF󂯎|C^
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::GetMixingMovieBGColor( unsigned long *col )
{
	HRESULT		hr;
	COLORREF	cr;
	if(FAILED(hr = MixerControl()->GetBackgroundClr( &cr )) )
		ThrowDShowException(L"Failed to set IVMRMixerControl9::GetBackgroundClr.", hr);
	*col = ChangeEndian32(cr);
	*col >>= 8;
}
//----------------------------------------------------------------------------
//! @brief	  	EBhEnhݒ肷
//! @param 		window : EBhEnh
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetWindow(HWND window)
{
	if(Shutdown) return;

	if( OwnerWindow != window )
	{
		CAutoLock Lock(&m_VMRLock);
		OwnerWindow = window;
		AllocatorPresenter()->Reset();
	}
}
//----------------------------------------------------------------------------
//! @brief	  	rfI̕\`ݒ肷
//! @param 		rect : \`
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetRect(RECT *rect)
{
	if(Shutdown) return;
	Rect = *rect;
	AllocatorPresenter()->SetRect(rect);
}
//----------------------------------------------------------------------------
//! @brief	  	rfI̕\/\ݒ肷
//! @param 		b : \/\
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetVisible(bool b)
{
	AllocatorPresenter()->SetVisible(b);
}
//----------------------------------------------------------------------------
//! @brief	  	rfĨTCY擾
//! @param 		width : 
//! @param 		height : 
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::GetVideoSize( long *width, long *height )
{
	if( width == NULL || height == NULL )
		TVPThrowExceptionMessage(L"Pointer is NULL.(tTVPDSMixerVideoOverlay::GetVideoSize)");

	*width = m_Width;
	*height = m_Height;
}
//----------------------------------------------------------------------------
//! @brief	  	et[̕ϕ\Ԃ擾
//! @param 		pAvgTimePerFrame : et[̕ϕ\
//! @return		G[R[h
//----------------------------------------------------------------------------
HRESULT __stdcall tTVPDSMixerVideoOverlay::GetAvgTimePerFrame( REFTIME *pAvgTimePerFrame )
{
	*pAvgTimePerFrame = (double)m_AvgTimePerFrame / 10000000.0;
	return S_OK;
}
//----------------------------------------------------------------------------
//! @brief	  	rfI摜ʂ֔f
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::PresentVideoImage()
{
	AllocatorPresenter()->PresentVideoImage();
}
//----------------------------------------------------------------------------
//! @brief	  	bZ[W𑗂EBhEݒ肷
//----------------------------------------------------------------------------
void __stdcall tTVPDSMixerVideoOverlay::SetMessageDrainWindow(HWND window)
{
	m_hMessageDrainWnd = window;
}
