#include "IrrlichtDrawDevice.h"
#include "LayerManagerInfo.h"

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace io;
using namespace gui;

extern void message_log(const char* format, ...);

/**
 * Irrlicht ĂяoJn
 */
void
tTVPIrrlichtDrawDevice::start()
{
	stop();
	TVPAddContinuousEventHook(this);
}

/**
 * Irrlicht Ăяo~
 */
void
tTVPIrrlichtDrawDevice::stop()
{
	TVPRemoveContinuousEventHook(this);
}

/**
 * Continuous R[obN
 * ggɂȂƂɏɌĂ΂
 * ꂪ̃C[vɂȂ
 */
void TJS_INTF_METHOD
tTVPIrrlichtDrawDevice::OnContinuousCallback(tjs_uint64 tick)
{
	if (device) {
		device->getTimer()->tick();

		/// hCo
		video::IVideoDriver* driver = device->getVideoDriver();

		dimension2d<s32> screenSize = driver->getScreenSize();
		
		// `Jn
		driver->beginScene(true, true, irr::video::SColor(255,0,0,0));

		/// V[}l[W̕`
		ISceneManager* smgr = device->getSceneManager();
		smgr->drawAll();

		// ʃC}l[W̕`
		for (std::vector<iTVPLayerManager *>::iterator i = Managers.begin(); i != Managers.end(); i++) {
			LayerManagerInfo *info = (LayerManagerInfo*)(*i)->GetDrawDeviceData();
			if (info && info->texture) {
				driver->draw2DImage(info->texture, core::position2d<s32>(0,0),
									core::rect<s32>(0,0,screenSize.Width,screenSize.Height), 0, 
									video::SColor(255,255,255,255), true);
			}
		}

		// GUI̕`
		device->getGUIEnvironment()->drawAll();

		// `抮
		driver->endScene();
	}
};

/**
 * Cxg
 * HWND w肵ĐĂ֌W Irrlicht g̓EChE
 * Cxg擾邱Ƃ͂ȂB̂ GUI Environment ̃Cxg
 * ɂ邱ƂɂȂH
 * @param event Cxg
 * @return  true
 */
bool
tTVPIrrlichtDrawDevice::OnEvent(const irr::SEvent &event)
{
	switch (event.EventType) {
	case EET_GUI_EVENT:
		message_log("GUICxg:%d", event.GUIEvent.EventType);
		switch(event.GUIEvent.EventType) {
		case EGET_BUTTON_CLICKED:
			message_log("{^ꂽ");
			break;
		}
		break;
	case EET_MOUSE_INPUT_EVENT:
#if 0
		message_log("}EXCxg:%d x:%d y:%d wheel:%f",
			event.MouseInput.Event,
			event.MouseInput.X,
			event.MouseInput.Y,
			event.MouseInput.Wheel);
#endif
		break;
	case EET_KEY_INPUT_EVENT:
//		message_log("L[Cxg:%x", event.KeyInput.Key);
		{
			int shift = 0;
			if (event.KeyInput.Shift) {
				shift |= 0x01;
			}
			if (event.KeyInput.Control) {
				shift |= 0x04;
			}
		}
		break;
	case EET_LOG_TEXT_EVENT:
		message_log("Ox:%d O:%s",
					event.LogEvent.Level,
					event.LogEvent.Text);
		break;
	case EET_USER_EVENT:
		message_log("[UCxg");
		break;
	}
	return false;
}
