#include "ncbind/ncbind.hpp"
#include <string>
using namespace std;
#include <tchar.h>
#include <shlobj.h>

// Date NXo
static iTJSDispatch2 *dateClass   = NULL;  // Date ̃NXIuWFNg
static iTJSDispatch2 *dateSetTime = NULL;  // Date.setTime \bh
static iTJSDispatch2 *dateGetTime = NULL;  // Date.getTime \bh

static const tjs_nchar * StoragesFstatPreScript	= TJS_N("\
global.FILE_ATTRIBUTE_READONLY = 0x00000001,\
global.FILE_ATTRIBUTE_HIDDEN = 0x00000002,\
global.FILE_ATTRIBUTE_SYSTEM = 0x00000004,\
global.FILE_ATTRIBUTE_DIRECTORY = 0x00000010,\
global.FILE_ATTRIBUTE_ARCHIVE = 0x00000020,\
global.FILE_ATTRIBUTE_NORMAL = 0x00000080,\
global.FILE_ATTRIBUTE_TEMPORARY = 0x00000100;");

NCB_TYPECONV_CAST_INTEGER(tjs_uint64);


/**
 * \bhǉp
 */
class StoragesFstat {
	/**
	 * Win32API GetLastError̃G[bZ[WԂ
	 * @param message bZ[Wi[
	 */
	static void getLastError(ttstr &message) {
		LPVOID lpMessageBuffer;
		FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
					   NULL, GetLastError(),
					   MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
					   (LPWSTR)&lpMessageBuffer, 0, NULL);
		message = ((tjs_char*)lpMessageBuffer);
		LocalFree(lpMessageBuffer);
	}

	/**
	 * t@C Date NXɂĕۑ
	 * @param store i[
	 * @param filetime t@C
	 */
	static void storeDate(tTJSVariant &store, FILETIME &filetime, iTJSDispatch2 *objthis)
	{
		// t@C
		tjs_uint64 ft = filetime.dwHighDateTime;
		ft *= 0x100000000;
		ft |= filetime.dwLowDateTime;
		if (ft > 0) {
			iTJSDispatch2 *obj;
			if (TJS_SUCCEEDED(dateClass->CreateNew(0, NULL, NULL, &obj, 0, NULL, objthis))) {
				// UNIX TIME ɕϊ
				tjs_int64 unixtime = (ft - 0x19DB1DED53E8000 ) / 10000;
				tTJSVariant time(unixtime);
				tTJSVariant *param[] = { &time };
				dateSetTime->FuncCall(0, NULL, NULL, NULL, 1, param, obj);
				store = tTJSVariant(obj, obj);
				obj->Release();
			}
		}
	}
	/**
	 * Date NX̎t@Cɕϊ
	 * @param restore  QƐiDateNXCX^Xj
	 * @param filetime t@Cʊi[
	 * @return 擾łǂ
	 */
	static bool restoreDate(tTJSVariant &restore, FILETIME &filetime)
	{
		if (restore.Type() != tvtObject) return false;
		iTJSDispatch2 *date = restore.AsObjectNoAddRef();
		if (!date) return false;
		tTJSVariant result;
		if (dateGetTime->FuncCall(0, NULL, NULL, &result, 0, NULL, date) != TJS_S_OK) return false;
		tjs_uint64 ft = result.AsInteger();
		ft *= 10000;
		ft += 0x19DB1DED53E8000;
		filetime.dwLowDateTime  = (DWORD)( ft        & 0xFFFFFFFF);
		filetime.dwHighDateTime = (DWORD)((ft >> 32) & 0xFFFFFFFF);
		return true;
	}

	/**
	 * pX[J違\폜
	 * @param path pX
	 */
	static void getLocalName(ttstr &path) {
		TVPGetLocalName(path);
		if (path.GetLastChar() == TJS_W('\\')) {
			tjs_int i,len = path.length();
			tjs_char* tmp = new tjs_char[len];
			const tjs_char* dp = path.c_str();
			for (i=0,len--; i<len; i++) tmp[i] = dp[i];
			tmp[i] = 0;
			path = tmp;
			delete[] tmp;
		}
	}

	/**
	 * t@Cnh擾
	 * @param filename t@Ci[Jł邱Ɓj
	 * @param iswrite ǂݏI
	 * @param out out_isdir fBNgǂ
	 * @return t@Cnh
	 */
	static HANDLE _getFileHandle(ttstr const &filename, bool iswrite, bool *out_isdir = 0) {
		DWORD attr = GetFileAttributes(filename.c_str());
		bool isdir = (attr != 0xFFFFFFFF && (attr & FILE_ATTRIBUTE_DIRECTORY));
		if (out_isdir) *out_isdir = isdir;
		HANDLE hFile;
		if (iswrite) {
			hFile = CreateFile(filename.c_str(), GENERIC_WRITE, FILE_SHARE_READ, NULL ,
							   OPEN_EXISTING,    isdir ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL , NULL);
		} else {
			hFile = CreateFile(filename.c_str(), isdir ? READ_CONTROL               : GENERIC_READ, 0, NULL ,
							   OPEN_EXISTING,    isdir ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL , NULL);
		}
		return hFile;
	}
	/**
	 * t@C̃^CX^v擾
	 * @param filename t@Ci[Jł邱Ɓj
	 * @param ctime 쐬
	 * @param atime ANZX
	 * @param mtime ύX
	 * @param size  t@CTCY
	 * @return 0:s 1:t@C 2:tH_
	 */
	static int getFileTime(ttstr const &filename, tTJSVariant &ctime, tTJSVariant &atime, tTJSVariant &mtime, tTJSVariant *size = 0)
	{
		bool isdir = false;
		HANDLE hFile = _getFileHandle(filename, false, &isdir);
		if (hFile == INVALID_HANDLE_VALUE) return 0;

		if (!isdir && size != 0) {
			LARGE_INTEGER fsize;
			if (GetFileSizeEx(hFile, &fsize))
				*size = (tjs_int64)fsize.QuadPart;
		}
		FILETIME ftc, fta, ftm;
		if (GetFileTime(hFile , &ftc, &fta, &ftm)) {
			storeDate(ctime, ftc, NULL);
			storeDate(atime, fta, NULL);
			storeDate(mtime, ftm, NULL);
		}
		CloseHandle(hFile);
		return isdir ? 2 : 1;
	}
	/**
	 * t@C̃^CX^vݒ肷
	 * @param filename t@Ci[Jł邱Ɓj
	 * @param ctime 쐬
	 * @param mtime ύX
	 * @param atime ANZX
	 * @return 0:s 1:t@C 2:tH_
	 */
	static int setFileTime(ttstr const &filename, tTJSVariant &ctime, tTJSVariant &atime, tTJSVariant &mtime)
	{
		bool isdir = false;
		HANDLE hFile = _getFileHandle(filename, true, &isdir);
		if (hFile == INVALID_HANDLE_VALUE) return 0;

		FILETIME c, a, m;
		bool hasC = restoreDate(ctime, c);
		bool hasA = restoreDate(atime, a);
		bool hasM = restoreDate(mtime, m);

		BOOL r = SetFileTime(hFile, hasC?&c:0, hasA?&a:0, hasM?&m:0);
		if (r == 0) {
			ttstr mes;
			getLastError(mes);
			TVPAddLog(ttstr(TJS_W("setFileTime : ")) + filename + TJS_W(":") + mes);
		}
		CloseHandle(hFile);
		return (r == 0) ? 0 : isdir ? 2 : 1;
	}
	static tjs_error _getTime(tTJSVariant *result, tTJSVariant const *param, bool chksize) {
		// t@CŃ`FbN
		ttstr filename = TVPNormalizeStorageName(param->AsStringNoAddRef());
		getLocalName(filename);
		tTJSVariant size, ctime, atime, mtime;
		int sel = getFileTime(filename, ctime, atime, mtime, chksize ? &size : 0);
		if (sel > 0) {
			if (result) {
				iTJSDispatch2 *dict = TJSCreateDictionaryObject();
				if (dict != NULL) {
					if (chksize && sel == 1) dict->PropSet(TJS_MEMBERENSURE, L"size",  NULL, &size, dict);
					dict->PropSet(TJS_MEMBERENSURE, L"mtime", NULL, &mtime, dict);
					dict->PropSet(TJS_MEMBERENSURE, L"ctime", NULL, &ctime, dict);
					dict->PropSet(TJS_MEMBERENSURE, L"atime", NULL, &atime, dict);
					*result = dict;
					dict->Release();
				}
			}
			return TJS_S_OK;
		}

		TVPThrowExceptionMessage((ttstr(TJS_W("cannot open : ")) + param->GetString()).c_str());
		return TJS_S_OK;
	}
public:
	StoragesFstat(){};

	/**
	 * w肳ꂽt@C̏擾
	 * @param filename t@C
	 * @return TCYE
	 */
	static tjs_error TJS_INTF_METHOD fstat(tTJSVariant *result,
										   tjs_int numparams,
										   tTJSVariant **param,
										   iTJSDispatch2 *objthis) {
		if (numparams < 1) return TJS_E_BADPARAMCOUNT;

		ttstr filename = TVPGetPlacedPath(*param[0]);
		if (filename.length() > 0 && wcschr(filename.c_str(), '>')) {
			// A[JCut@C
			IStream *in = TVPCreateIStream(filename, TJS_BS_READ);
			if (in) {
				STATSTG stat;
				in->Stat(&stat, STATFLAG_NONAME);
				tTJSVariant size((tjs_int64)stat.cbSize.QuadPart);
				if (result) {
					iTJSDispatch2 *dict;
					if ((dict = TJSCreateDictionaryObject()) != NULL) {
						dict->PropSet(TJS_MEMBERENSURE, L"size",  NULL, &size, dict);
						*result = dict;
						dict->Release();
					}
				}
				in->Release();
				return TJS_S_OK;
			}
		}
		return _getTime(result, param[0], true);
	}
	/**
	 * w肳ꂽt@C̃^CX^v擾iA[JCusj
	 * @param filename t@C
	 * @param dict     
	 * @return ǂ
	 */
	static tjs_error TJS_INTF_METHOD getTime(tTJSVariant *result,
											 tjs_int numparams,
											 tTJSVariant **param,
											 iTJSDispatch2 *objthis) {
		if (numparams < 1) return TJS_E_BADPARAMCOUNT;
		return _getTime(result, param[0], false);
	}
	/**
	 * w肳ꂽt@C̃^CX^vݒ肷
	 * @param filename t@C
	 * @param dict     
	 * @return ǂ
	 */
	static tjs_error TJS_INTF_METHOD setTime(tTJSVariant *result,
											 tjs_int numparams,
											 tTJSVariant **param,
											 iTJSDispatch2 *objthis) {
		if (numparams < 2) return TJS_E_BADPARAMCOUNT;

		ttstr filename = TVPNormalizeStorageName(param[0]->AsStringNoAddRef());
		getLocalName(filename);
		tTJSVariant size, ctime, atime, mtime;
		iTJSDispatch2 *dict = param[1]->AsObjectNoAddRef();
		if (dict != NULL) {
			dict->PropGet(0, L"ctime", NULL, &ctime, dict);
			dict->PropGet(0, L"atime", NULL, &atime, dict);
			dict->PropGet(0, L"mtime", NULL, &mtime, dict);
		}
		int sel = setFileTime(filename, ctime, atime, mtime);
		if (result) *result = (sel > 0);

		return TJS_S_OK;
	}

	/**
	 * XV擾EݒiDateoRȂŁj
	 * @param target Ώ
	 * @param time ԁi64bit FILETIMEj
	 */
	static tjs_uint64 getLastModifiedFileTime(ttstr target) {
		ttstr filename = TVPNormalizeStorageName(target);
		getLocalName(filename);
		HANDLE hFile = _getFileHandle(filename, false);
		FILETIME ft;
		if (hFile == INVALID_HANDLE_VALUE ||
			!GetFileTime(hFile, 0, 0, &ft)) return 0;
		tjs_uint64 ret = ft.dwHighDateTime;
		ret <<= 32;
		ret |= ft.dwLowDateTime;
		return ret;
	}
	static bool setLastModifiedFileTime(ttstr target, tjs_uint64 time) {
		ttstr filename = TVPNormalizeStorageName(target);
		getLocalName(filename);
		HANDLE hFile = _getFileHandle(filename, true);
		FILETIME ft;
		ft.dwHighDateTime = (time >> 32) & 0xFFFFFFFF;
		ft.dwLowDateTime  =  time        & 0xFFFFFFFF;
		return (hFile != INVALID_HANDLE_VALUE && SetFileTime(hFile, 0, 0, &ft));
	}

	/**
	 * gg̃Xg[WԒ̃t@C𒊏o
	 * @param src ۑt@C
	 * @param dest ۑt@C
	 */
	static void exportFile(const char *src, const char *dest) {
		ttstr filename = src;
		IStream *in = TVPCreateIStream(filename, TJS_BS_READ);
		if (in) {
			ttstr storename = dest;
			IStream *out = TVPCreateIStream(storename, TJS_BS_WRITE);
			if (out) {
				BYTE buffer[1024*16];
				DWORD size;
				while (in->Read(buffer, sizeof buffer, &size) == S_OK && size > 0) {			
					out->Write(buffer, size, &size);
				}
				out->Release();
				in->Release();
			} else {
				in->Release();
				TVPThrowExceptionMessage((ttstr(TJS_W("cannot open storefile: ")) + storename).c_str());
			}
		} else {
			TVPThrowExceptionMessage((ttstr(TJS_W("cannot open readfile: ")) + filename).c_str());
		}
	}

	/**
	 * gg̃Xg[WԒ̎wt@C폜B
	 * @param file 폜Ώۃt@C
	 * @return ۂɍ폜ꂽ true
	 * t@Cꍇ̂ݍ폜܂
	 */
	static bool deleteFile(ttstr filename) {
		filename = TVPGetPlacedPath(filename);
		if (filename.length() && !wcschr(filename.c_str(), '>')) {
			TVPGetLocalName(filename);
			if (DeleteFile(filename.c_str())) {
				return true;
			}
		}
		return false;
	}

	/**
	 * wt@CړB
	 * @param fromFile ړΏۃt@C
	 * @param toFile ړpX
	 * @return ۂɈړꂽ true
	 * ړΏۃt@C݂AړpXɃt@Cꍇ݈̂ړ܂
	 */
	static bool moveFile(ttstr fromFile, ttstr toFile) {
		if (fromFile.length() && !wcschr(fromFile.c_str(), '>')
                    && toFile.length() && !wcschr(toFile.c_str(), '>')) {
			TVPGetLocalName(fromFile);
			TVPGetLocalName(toFile);
			if (MoveFile(fromFile.c_str(), toFile.c_str())) {
				return true;
			}
                    }
		return false;
	}
  
	/**
	 * wfBNg̃t@Cꗗ擾
	 * @param dir fBNg
	 * @return t@Cꗗi[ꂽz
	 */
	static tTJSVariant dirlist(ttstr dir) {

		// OSlCeBuȕ\ɕϊ
		dir = TVPNormalizeStorageName(dir);
		if (dir.GetLastChar() != TJS_W('/')) {
			TVPThrowExceptionMessage(TJS_W("'/' must be specified at the end of given directory name."));
		}
		TVPGetLocalName(dir);

		// Array NX̃IuWFNg쐬
		iTJSDispatch2 * array = TJSCreateArrayObject();
		tTJSVariant result;
		
		try {
			ttstr wildcard = dir + "*.*";
			WIN32_FIND_DATA data;
			HANDLE handle = FindFirstFile(wildcard.c_str(), &data);
			if (handle != INVALID_HANDLE_VALUE) {
				tjs_int count = 0;
				do {
					ttstr file = dir;
					file += data.cFileName;
					if (GetFileAttributes(file.c_str()) & FILE_ATTRIBUTE_DIRECTORY) {
						// fBNg̏ꍇ͍Ō / 
						file = data.cFileName;
						file += "/";
					} else {
						// ʂ̃t@C̏ꍇ͂̂܂
						file = data.cFileName;
					}
					// zɒǉ
					tTJSVariant val(file);
					array->PropSetByNum(0, count++, &val, array);
				} while(FindNextFile(handle, &data));
				FindClose(handle);
			} else {
				TVPThrowExceptionMessage(TJS_W("Directory not found."));
			}
			result = tTJSVariant(array, array);
			array->Release();
		} catch(...) {
			array->Release();
			throw;
		}

		return result;
	}

	/**
	 * wfBNg폜
	 * @param dir fBNg
	 * @return ۂɍ폜ꂽ true
	 * Ƀt@Cꍇ̂ݍ폜܂
	 */
	static bool removeDirectory(ttstr dir) {

		if (dir.GetLastChar() != TJS_W('/')) {
			TVPThrowExceptionMessage(TJS_W("'/' must be specified at the end of given directory name."));
		}

		// OSlCeBuȕ\ɕϊ
		dir = TVPNormalizeStorageName(dir);
		TVPGetLocalName(dir);

		return RemoveDirectory(dir.c_str()) == TRUE;
	}

	/**
	 * fBNg̍쐬
	 * @param dir fBNg
	 * @return ۂɍ쐬ł true
	 */
	static bool createDirectory(ttstr dir)
	{
		if(dir.GetLastChar() != TJS_W('/'))
		{
			TVPThrowExceptionMessage(TJS_W("'/' must be specified at the end of given directory name."));
		}
		dir	= TVPNormalizeStorageName(dir);
		TVPGetLocalName(dir);
		return CreateDirectory(dir.c_str(), NULL) == TRUE;
	}

	/**
	 * t@C̑ݒ肷
	 * @param filename t@C/fBNg
	 * @param attr ݒ肷鑮
	 * @return ۂɕύXł true
	 */
	static bool setFileAttributes(ttstr filename, DWORD attr)
	{
		filename	= TVPNormalizeStorageName(filename);
		TVPGetLocalName(filename);

		attr	= attr & (FILE_ATTRIBUTE_NORMAL | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN |
			FILE_ATTRIBUTE_ARCHIVE | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_TEMPORARY);

		DWORD	orgattr = GetFileAttributes(filename.c_str());

		return SetFileAttributes(filename.c_str(), orgattr | attr) == TRUE;
	}

	/**
	 * t@C̑
	 * @param filename t@C/fBNg
	 * @param attr 鑮
	 * @return ۂɕύXł true
	 */
	static bool resetFileAttributes(ttstr filename, DWORD attr)
	{
		filename	= TVPNormalizeStorageName(filename);
		TVPGetLocalName(filename);

		attr	= attr & (FILE_ATTRIBUTE_NORMAL | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN |
			FILE_ATTRIBUTE_ARCHIVE | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_TEMPORARY);

		DWORD	orgattr = GetFileAttributes(filename.c_str());

		return SetFileAttributes(filename.c_str(), orgattr & ~attr) == TRUE;
	}

	/**
	 * t@C̑擾
	 * @param filename t@C/fBNg
	 * @return 擾
	 */
	static DWORD getFileAttributes(ttstr filename)
	{
		filename	= TVPNormalizeStorageName(filename);
		TVPGetLocalName(filename);

		return GetFileAttributes(filename.c_str());
	}

	/**
	 * tH_I_CAOJ
	 * @param window EBhE
	 * @param caption LvV
	 * @param initialDir fBNg
	 * @param rootDir [gfBNg
	 */
	static tjs_error TJS_INTF_METHOD selectDirectory(
		tTJSVariant	*result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis)
	{
		if(numparams < 1)
			return TJS_E_BADPARAMCOUNT;

		iTJSDispatch2*	tmp;
		tTJSVariant		val;
		BROWSEINFO		bi;
		ITEMIDLIST*		rootidl	= NULL;
		tjs_char		folder[2048+1];
		memset(&bi, 0, sizeof(bi));

		//	HWND
		iTJSDispatch2*	elm	= param[0]->AsObjectNoAddRef();
		if(elm->IsValid(0, L"window", NULL, elm) == TJS_S_TRUE &&
			TJS_SUCCEEDED(elm->PropGet(0, L"window", NULL, &val, elm)) &&
			val.IsInstanceOf(L"Window"))
		{
			tmp	= val.AsObjectNoAddRef();
			if(TJS_SUCCEEDED(tmp->PropGet(0, L"HWND", NULL, &val, tmp)))
				bi.hwndOwner	= (HWND)val.AsInteger();
			else
				bi.hwndOwner	= TVPGetApplicationWindowHandle();
		}
		else
			bi.hwndOwner	= NULL;

		//	title
		if(elm->IsValid(0, L"title", NULL, elm) == TJS_S_TRUE &&
			TJS_SUCCEEDED(elm->PropGet(0, L"title", NULL, &val, elm)))
		{
			ttstr	title	= val.AsStringNoAddRef();
			bi.lpszTitle	= title.c_str();
		}
		else
			bi.lpszTitle	= NULL;

		//	name
		bi.pszDisplayName	= NULL;
		bi.ulFlags	= BIF_RETURNONLYFSDIRS;/* BIF_NEWDIALOGSTYLE */
		if(elm->IsValid(0, L"name", NULL, elm) == TJS_S_TRUE &&
			TJS_SUCCEEDED(elm->PropGet(0, L"name", NULL, &val, elm)) &&
			!val.NormalCompare(ttstr(L"")))
		{
			ttstr	name	= TVPNormalizeStorageName(val.AsStringNoAddRef());
			TVPGetLocalName(name);
			_tcscpy_s(folder, 2048, name.c_str());
		}
		else
			folder[0]	= 0;

		//	root dir
		if(elm->IsValid(0, L"rootDir", NULL, elm) == TJS_S_TRUE &&
			TJS_SUCCEEDED(elm->PropGet(0, L"rootDir", NULL, &val, elm)))
		{
			ttstr	rootDir	= TVPNormalizeStorageName(val.AsStringNoAddRef());
			TVPGetLocalName(rootDir);
			rootidl	= Path2ITEMIDLIST(rootDir.c_str());
		}
		bi.pidlRoot	= rootidl;

		bi.lpfn		= SelectDirectoryCallBack;
		bi.lParam	= (LPARAM)folder;

		ITEMIDLIST*	pidl;
		if((pidl = ::SHBrowseForFolder(&bi)) != NULL)
		{
			if(::SHGetPathFromIDList(pidl, folder) != TRUE)
				*result	= 0;
			else
			{
				*result	= TJS_S_TRUE;
				val	= folder;
				elm->PropSet(0, L"name", NULL, &val, elm);
			}
			FreeITEMIDLIST(pidl);
		}
		else
			*result	= 0;
		FreeITEMIDLIST(rootidl);

		return TJS_S_OK;
	}

	/**
	 * fBNg̑݃`FbN
	 * @param directory fBNg
	 * @return fBNg݂ true/݂Ȃ -1/fBNgłȂ false
	 */
	static tjs_error TJS_INTF_METHOD isExistentDirectory(
		tTJSVariant	*result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis)
	{
		if(numparams < 1) return TJS_E_BADPARAMCOUNT;

		if(result == NULL)
			return TJS_S_OK;

		if(param[0]->NormalCompare(ttstr(L"")))
		{
			*result	= (tTVInteger)-1;
			return TJS_S_OK;
		}

		ttstr	dir = TVPNormalizeStorageName(param[0]->AsStringNoAddRef());
		getLocalName(dir);
		DWORD	attr = GetFileAttributes(dir.c_str());
		if(attr == 0xFFFFFFFF)
			*result	= (tTVInteger)-1;	//	݂Ȃ
		else if((attr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
			*result	= (tTVInteger)TJS_S_TRUE;	//	݂
		else
			*result	= (tTVInteger)0;	//	fBNgł͂Ȃ

		return TJS_S_OK;
	}

private:
	//	w̃pXITEMIDLIST擾
	static ITEMIDLIST*	Path2ITEMIDLIST(const tjs_char* path)
	{
		IShellFolder* isf;
		ITEMIDLIST* pidl;
		if(SUCCEEDED(::SHGetDesktopFolder(&isf)))
		{
			ULONG	tmp;
			if(SUCCEEDED(isf->ParseDisplayName(NULL, NULL, (LPOLESTR)path, &tmp, &pidl, &tmp)))
				return pidl;
		}
		return NULL;
	}

	//	ITEMIDLIST
	static void	FreeITEMIDLIST(ITEMIDLIST* pidl)
	{
		IMalloc*	im;
		if(::SHGetMalloc(&im) != NOERROR)
			im	= NULL;
		if(im != NULL)
			im->Free((void*)pidl);
	}

	//	SHBrowserForFolder̃R[obN֐
	static int	CALLBACK SelectDirectoryCallBack(HWND hwnd, UINT msg, LPARAM lparam, LPARAM lpdata)
	{
		//	
		if(msg == BFFM_INITIALIZED)
		{
			//	tH_w
			ITEMIDLIST*	pidl;
			pidl	= Path2ITEMIDLIST((tjs_char*)lpdata);
			if(pidl != NULL)
			{
				::SendMessage(hwnd, BFFM_SETSELECTION, FALSE, (LPARAM)pidl);
				FreeITEMIDLIST(pidl);
			}

			//	őOʂֈړ
			SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		}
		return 0;
	}
};

NCB_ATTACH_CLASS(StoragesFstat, Storages) {
	RawCallback("fstat",               &Class::fstat,               TJS_STATICMEMBER);
	RawCallback("getTime",             &Class::getTime,             TJS_STATICMEMBER);
	RawCallback("setTime",             &Class::setTime,             TJS_STATICMEMBER);
	NCB_METHOD(getLastModifiedFileTime);
	NCB_METHOD(setLastModifiedFileTime);
	NCB_METHOD(exportFile);
	NCB_METHOD(deleteFile);
	NCB_METHOD(moveFile);
	NCB_METHOD(dirlist);
	NCB_METHOD(removeDirectory);
	NCB_METHOD(createDirectory);
	NCB_METHOD(setFileAttributes);
	NCB_METHOD(resetFileAttributes);
	NCB_METHOD(getFileAttributes);
	RawCallback("selectDirectory",     &Class::selectDirectory,     TJS_STATICMEMBER);
	RawCallback("isExistentDirectory", &Class::isExistentDirectory, TJS_STATICMEMBER);
};

/**
 * o^
 */
static void PostRegistCallback()
{
	tTJSVariant var;
	TVPExecuteExpression(TJS_W("Date"), &var);
	dateClass = var.AsObject();
	var.Clear();
	TVPExecuteExpression(TJS_W("Date.setTime"), &var);
	dateSetTime = var.AsObject();
	var.Clear();
	TVPExecuteExpression(TJS_W("Date.getTime"), &var);
	dateGetTime = var.AsObject();
	var.Clear();
	TVPExecuteExpression(StoragesFstatPreScript);
}

#define RELEASE(name) name->Release();name= NULL

/**
 * JO
 */
static void PreUnregistCallback()
{
	RELEASE(dateClass);
	RELEASE(dateSetTime);
}

NCB_POST_REGIST_CALLBACK(PostRegistCallback);
NCB_PRE_UNREGIST_CALLBACK(PreUnregistCallback);
