#ifndef _layExText_hpp_
#define _layExText_hpp_

#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;

#include <vector>
using namespace std;

#include "layerExBase.hpp"

/**
 * GDIPlus ŗLp
 */
struct GdiPlus {
	/**
	 * vCx[gtHg̒ǉ
	 * @param fontFileName tHgt@C
	 */
	static void addPrivateFont(const tjs_char *fontFileName);

	/**
	 * vCx[gtHgꗗOɏo
	 */
	static void showPrivateFontList();
};

/**
 * tHg
 */
class FontInfo {
	friend class LayerExText;

protected:
	FontFamily *fontFamily; //< tHgt@~[
	ttstr familyName;
	REAL emSize; //< tHgTCY 
	INT style; //< tHgX^C

	/**
	 * tHg̃NA
	 */
	void clear();

public:

	FontInfo();
	/**
	 * RXgN^
	 * @param familyName tHgt@~[
	 * @param emSize tHg̃TCY
	 * @param style tHgX^C
	 */
	FontInfo(const tjs_char *familyName, REAL emSize, INT style);
	FontInfo(const FontInfo &orig);

	/**
	 * fXgN^
	 */
	virtual ~FontInfo();

	void setFamilyName(const tjs_char *familyName);
	const tjs_char *getFamilyName() { return familyName.c_str(); }
	void setEmSize(REAL emSize) { this->emSize = emSize; }
	REAL getEmSize() {  return emSize; }
	void setStyle(INT style) { this->style = style; }
	INT getStyle() { return style; }
};

/**
 * `OϏ
 */
class Appearance {
	friend class LayerExText;
public:
	// `
	struct DrawInfo{
		int type;   // 0:uV 1:y
		void *info; // IuWFNg
		REAL ox; //< \ItZbg
		REAL oy; //< \ItZbg
		DrawInfo() : ox(0), oy(0), type(0), info(NULL) {}
		DrawInfo(REAL ox, REAL oy, Pen *pen) : ox(ox), oy(oy), type(0), info(pen) {}
		DrawInfo(REAL ox, REAL oy, Brush *brush) : ox(ox), oy(oy), type(1), info(brush) {}
		DrawInfo(const DrawInfo &orig) {
			ox = orig.ox;
			oy = orig.oy;
			type = orig.type;
			if (orig.info) {
				switch (type) {
				case 0:
					info = (void*)((Pen*)orig.info)->Clone();
					break;
				case 1:
					info = (void*)((Brush*)orig.info)->Clone();
					break;
				}
			} else {
				info = NULL;
			}
		}
		virtual ~DrawInfo() {
			if (info) {
				switch (type) {
				case 0:
					delete (Pen*)info;
					break;
				case 1:
					delete (Brush*)info;
					break;
				}
			}
		}	
	};
	vector<DrawInfo>drawInfos;

public:
	Appearance();
	virtual ~Appearance();

	/**
	 * ̃NA
	 */
	void clear();
	
	/**
	 * ŒFuV̒ǉ
	 * @param argb Fw
	 * @param ox \ItZbgX
	 * @param oy \ItZbgY
	 */
	void addSolidBrush(ARGB argb, REAL ox=0, REAL oy=0);

	/**
	 * Of[VuV̒ǉ
	 * @param x1
	 * @param y1
	 * @param argb1 Fw肻̂P
	 * @param x1
	 * @param y1
	 * @param argb1 Fw肻̂Q
	 * @param ox \ItZbgX
	 * @param oy \ItZbgY
	 */
	void addLinearGradientBrush(REAL x1, REAL y1, ARGB argb1, REAL x2, REAL y2, ARGB argb2, REAL ox=0, REAL oy=0);
	
	/**
	 * ŒFy̒ǉ
	 * @param argb Fw
	 * @param width y
	 * @param ox \ItZbgX
	 * @param oy \ItZbgY
	 */
	void addColorPen(ARGB argb, REAL width=1.0, REAL ox=0, REAL oy=0);
};

/*
 * AEgCx[X̃eLXg`惁\bh̒ǉ
 */
class LayerExText : public layerExBase
{
protected:
	// ێp
	GeometryT width, height;
	BufferT   buffer;
	PitchT    pitch;
	
	/// CQƂrbg}bv
	Bitmap *bitmap;
	/// Cɑ΂ĕ`悷ReLXg
	Graphics *graphics;

public:	
	LayerExText(DispatchT obj);
	~LayerExText();
	virtual void reset();

public:
	/**
	 * o^ς݃uV/yɂ镶̕`
	 * @param font tHg
	 * @param app AsAX
	 * @param x `ʒuX
	 * @param y `ʒuY
	 * @param text `eLXg
	 * @param noupdate ʍXVsȂ
	 */
	void drawString(FontInfo *font, Appearance *app, REAL x, REAL y, const tjs_char *text, bool noupdate=false);
};

#endif
