#include <windows.h>
#include <tchar.h>
#include <process.h>
#include "ncbind/ncbind.hpp"

#define WM_SHELLEXECUTED (WM_APP+1)

/**
 * \bhǉpNX
 */
class WindowShell {

protected:
	iTJSDispatch2 *objthis; //< IuWFNg̎Q

	// Cxg
	static bool __stdcall shellExecuted(void *userdata, tTVPWindowMessage *Message) {
		if (Message->Msg == WM_SHELLEXECUTED) {
			iTJSDispatch2 *obj = (iTJSDispatch2*)userdata;
			tTJSVariant process = (tjs_int)Message->WParam;
			tTJSVariant endCode = (tjs_int)Message->LParam;
			tTJSVariant *p[] = {&process, &endCode};
			obj->FuncCall(0, L"onShellExecuted", NULL, NULL, 2, p, obj);
			return true;
		}
		return false;
	}
	
	// [UbZ[WV[o̓o^/
	void setReceiver(tTVPWindowMessageReceiver receiver, bool enable) {
		tTJSVariant mode     = enable ? (tTVInteger)(tjs_int)wrmRegister : (tTVInteger)(tjs_int)wrmUnregister;
		tTJSVariant proc     = (tTVInteger)(tjs_int)receiver;
		tTJSVariant userdata = (tTVInteger)(tjs_int)objthis;
		tTJSVariant *p[] = {&mode, &proc, &userdata};
		if (objthis->FuncCall(0, L"registerMessageReceiver", NULL, NULL, 4, p, objthis) != TJS_S_OK) {
			TVPThrowExceptionMessage(L"can't regist user message receiver");
		}
	}
	
public:
	// RXgN^
	WindowShell(iTJSDispatch2 *objthis) : objthis(objthis) {
		setReceiver(shellExecuted, true);
	}

	// fXgN^
	~WindowShell() {
		setReceiver(shellExecuted, false);
	}

public:
	/**
	 * s
	 */
	struct ExecuteInfo {
		HANDLE process;         // ҂ΏۃvZX
		iTJSDispatch2 *objthis; // this ێp
		ExecuteInfo(HANDLE process, iTJSDispatch2 *objthis) : process(process), objthis(objthis) {};
	};
	
	/**
	 * I҂Xbh
	 * @param data [U(ExecuteInfo)
	 */
	static void waitProcess(void *data) {
		// p[^p
		HANDLE process         = ((ExecuteInfo*)data)->process;
		iTJSDispatch2 *objthis = ((ExecuteInfo*)data)->objthis;
		delete data;

		// vZX҂
		WaitForSingleObject(process, INFINITE);
		DWORD dt;
		GetExitCodeProcess(process, &dt); // ʎ擾
		CloseHandle(process);

		// M
		tTJSVariant val;
		objthis->PropGet(0, TJS_W("HWND"), NULL, &val, objthis);
		PostMessage(reinterpret_cast<HWND>((tjs_int)(val)), WM_SHELLEXECUTED, (WPARAM)process, (LPARAM)dt);
	}
	
	/**
	 * vZX̒~
	 * @param keyName ʃL[
	 * @param endCode IR[h
	 */
	void terminateProcess(int process, int endCode) {
		TerminateProcess((HANDLE)process, endCode);
	}

	/**
	 * vZX̎s
	 * @param keyName ʃL[
	 * @param target ^[Qbg
	 * @praam param p[^
	 */
	int shellExecute(LPCTSTR target, LPCTSTR param) {
		SHELLEXECUTEINFO si;
		ZeroMemory(&si, sizeof(si));
		si.cbSize = sizeof(si);
		si.lpVerb = _T("open");
		si.lpFile = target;
		si.lpParameters = param;
		si.nShow = SW_SHOWNORMAL;
		si.fMask = SEE_MASK_FLAG_NO_UI | SEE_MASK_NOCLOSEPROCESS;
		if (ShellExecuteEx(&si)) {
			_beginthread(waitProcess, 0, new ExecuteInfo(si.hProcess, objthis));
			return (int)si.hProcess;
		}
		return (int)INVALID_HANDLE_VALUE;
	}

};

// CX^XQb^
NCB_GET_INSTANCE_HOOK(WindowShell)
{
	NCB_INSTANCE_GETTER(objthis) { // objthis  iTJSDispatch2* ^̈Ƃ
		ClassT* obj = GetNativeInstance(objthis);	// lCeBuCX^X|C^擾
		if (!obj) {
			obj = new ClassT(objthis);				// Ȃꍇ͐
			SetNativeInstance(objthis, obj);		// objthis  obj lCeBuCX^XƂēo^
		}
		return obj;
	}
};

// tbNA^b`
NCB_ATTACH_CLASS_WITH_HOOK(WindowShell, Window) {
	Method(L"shellExecute", &WindowShell::shellExecute);
	Method(L"terminateProcess", &WindowShell::terminateProcess);
}
