//---------------------------------------------------------------------------
/*
	TVP2 ( T Visual Presenter 2 )  A script authoring tool
	Copyright (C) 2000-2008 W.Dee <dee@kikyou.info> and contributors

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------
//!@file `foCXǗ
//---------------------------------------------------------------------------
#ifndef DRAWDEVICE_H
#define DRAWDEVICE_H

#include "LayerIntf.h"
#include "LayerManager.h"
#include "ComplexRect.h"

class iTVPWindow;
class tTJSNI_BaseLayer;

/*[*/
//---------------------------------------------------------------------------
//! @brief		`foCXC^[tF[X
//---------------------------------------------------------------------------
class iTVPDrawDevice
{
public:
//---- IuWFNgԐ
	//! @brief		(WindowDrawDevice) `foCXj
	//! @note		EBhEjƂA邢͂ق̕`foCX
	//!				ݒ肳ꂽ߂ɂ̕`foCXKvȂȂۂɌĂ΂B
	//!				ʏAł delete this sA`foCXj邪ȂO
	//!				AddLayerManager() ł̕`foCX̊ǗɓĂ
	//!				C}l[Wׂ Release B
	//!				C}l[W Release  RemoveLayerManager() Ă΂
	//!				\邱Ƃɒӂ邱ƁB
	virtual void TJS_INTF_METHOD Destruct() = 0;

//---- window interface ֘A
	//! @brief		(WindowDrawDevice) EBhEC^[tF[Xݒ肷
	//! @param		window		EBhEC^[tF[X
	//! @note		(TJS) Window.drawDevice vpeBݒ肵ɌĂ΂B
	virtual void TJS_INTF_METHOD SetWindowInterface(iTVPWindow * window) = 0;

//---- LayerManager ̊Ǘ֘A
	//! @brief		(WindowDrawDevice) C}l[Wǉ
	//! @note		vC}CEBhEɒǉƁAIɃC}l[W
	//!				쐬Aꂪ`foCXɂ̃\bȟĂяoɂĒʒmB
	//!				`foCXł iTVPLayerManager::AddRef() ĂяoāAǉꂽ
	//!				C}l[WbN邱ƁB
	virtual void TJS_INTF_METHOD AddLayerManager(iTVPLayerManager * manager) = 0;

	//! @brief		(WindowDrawDevice) C}l[W폜
	//! @note		vC}C invalidate ۂɌĂяoB
	//TODO: vC}CA邢̓EBhEj̏IH
	virtual void TJS_INTF_METHOD RemoveLayerManager(iTVPLayerManager * manager) = 0;

//---- `ʒuETCY֘A
	//! @brief		(WindowDrawDevice) `EBhE̐ݒ
	//! @param		wnd		EBhEnh
	//! @param		is_main	CEBhȄꍇɐ^
	//! @note		EBhE`ƂȂEBhEnhw肷邽߂ɌĂ΂B
	//!				΂΁AWindow.borderStyle vpeBύXꂽAtXN[
	//!				ڍsƂtXN[߂鎞ȂǁAEBhEč쐬
	//!				Ƃ邪Â悤ȏꍇɂ́AEBhEj钼O
	//!				wnd = NULL ̏Ԃł̃\bhĂ΂邱ƂɒӁBEBhE쐬
	//!				ꂽƁAĂїLȃEBhEnh𔺂Ẵ\bhĂ΂B
	//!				̃\bh́AEBhE쐬ꂽɌĂ΂ۏ؂͂ȂB
	//!				ĂAԍŏɃEBhE\ꂽɌĂ΂B
	virtual void TJS_INTF_METHOD SetTargetWindow(HWND wnd, bool is_main) = 0;

	//! @brief		(Window->DrawDevice) ``̐ݒ
	//! @note		EBhEA`ƂȂ`ݒ肷邽߂ɌĂ΂B
	//!				`foCX́ASetTargetWindow() Ŏw肳ꂽEBhẼNCAg̈́A
	//!				̃\bhŎw肳ꂽ`ɕ\sKvB
	//!				̋`́AGetSrcSize ŕԂlɑ΂AWindow.zoomNumer  Window.zoomDenum
	//!				vpeBɂg嗦AWindow.layerLeft  Window.layerTop ꂽ
	//!				`łB
	//!				̃\bhɂĕ``ςƂĂÃ^C~O
	//!				`foCXōĕ`sKv͂Ȃ(KvΕʃ\bhɂ
	//!				ĕ`̕Kvʒm邽)B
	virtual void TJS_INTF_METHOD SetDestRectangle(const tTVPRect & rect) = 0;

	//! @brief		(Window->DrawDevice) 摜̃TCY𓾂
	//! @note		EBhEA``̃TCY肷邽߂Ɍ摜̃TCY
	//!				KvɂȂۂɌĂ΂BEBhE͂Ƃ SetDestRectangle()
	//!				\bhŕ``ʒmĂ邾Ȃ̂ŁA
	//!				Ȃ炩̈Ӗ̂TCYłKv͕KȂB
	virtual void TJS_INTF_METHOD GetSrcSize(tjs_int &w, tjs_int &h) = 0;

	//! @brief		(LayerManagerDrawDevice) CTCYύX̒ʒm
	//! @param		manager		C}l[W
	//! @note		C}l[WɃA^b`ĂvC}C̃TCYς
	//!				ۂɌĂяo
	virtual void TJS_INTF_METHOD NotifyLayerResize(iTVPLayerManager * manager) = 0;

	//! @brief		(LayerManagerDrawDevice) C̉摜̕ύX̒ʒm
	//! @param		manager		C}l[W
	//! @note		C̉摜ɕωۂɌĂяoB
	//!				̒ʒm󂯎 iTVPLayerManager::UpdateToDrawDevice()
	//!				Ăяo΁AY`foCXɑ΂ĕ`悳邱ƂłB
	//!				̒ʒm󂯎Ă邱Ƃ͉\B̏ꍇ́A
	//!				 iTVPLayerManager::UpdateToDrawDevice() Ă񂾍ۂɁA
	//!				܂ł̕ύXׂĕ`悳B
	virtual void TJS_INTF_METHOD NotifyLayerImageChange(iTVPLayerManager * manager) = 0;

//---- [U[C^[tF[X֘A
	//! @brief		(WindowDrawDevice) NbNꂽ
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	virtual void TJS_INTF_METHOD OnClick(tjs_int x, tjs_int y) = 0;

	//! @brief		(WindowDrawDevice) _uNbNꂽ
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	virtual void TJS_INTF_METHOD OnDoubleClick(tjs_int x, tjs_int y) = 0;

	//! @brief		(WindowDrawDevice) }EX{^ꂽ
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	//! @param		mb		ǂ̃}EX{^
	//! @param		flags	tO(TVP_SS_*萔̑gݍ킹)
	virtual void TJS_INTF_METHOD OnMouseDown(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags) = 0;

	//! @brief		(WindowDrawDevice) }EX{^ꂽ
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	//! @param		mb		ǂ̃}EX{^
	//! @param		flags	tO(TVP_SS_*萔̑gݍ킹)
	virtual void TJS_INTF_METHOD OnMouseUp(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags) = 0;

	//! @brief		(WindowDrawDevice) }EXړ
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	//! @param		flags	tO(TVP_SS_*萔̑gݍ킹)
	virtual void TJS_INTF_METHOD OnMouseMove(tjs_int x, tjs_int y, tjs_uint32 flags) = 0;

	//! @brief		(WindowDrawDevice) C̃}EXLv`
	//! @note		C̃}EXLv`ׂꍇɃEBhEĂ΂B
	//! @note		WindowReleaseCapture() ƍȂƁB
	virtual void TJS_INTF_METHOD OnReleaseCapture() = 0;

	//! @brief		(WindowDrawDevice) }EX``OɈړ
	virtual void TJS_INTF_METHOD OnMouseOutOfWindow() = 0;

	//! @brief		(WindowDrawDevice) L[ꂽ
	//! @param		key		zL[R[h
	//! @param		shift	VtgL[̏
	virtual void TJS_INTF_METHOD OnKeyDown(tjs_uint key, tjs_uint32 shift) = 0;

	//! @brief		(WindowDrawDevice) L[ꂽ
	//! @param		key		zL[R[h
	//! @param		shift	VtgL[̏
	virtual void TJS_INTF_METHOD OnKeyUp(tjs_uint key, tjs_uint32 shift) = 0;

	//! @brief		(WindowDrawDevice) L[ɂ
	//! @param		key		R[h
	virtual void TJS_INTF_METHOD OnKeyPress(tjs_char key) = 0;

	//! @brief		(WindowDrawDevice) }EXzC[]
	//! @param		shift	VtgL[̏
	//! @param		delta	]p
	//! @param		x		``ɂ x ʒu(``̍オ_)
	//! @param		y		``ɂ y ʒu(``̍オ_)
	virtual void TJS_INTF_METHOD OnMouseWheel(tjs_uint32 shift, tjs_int delta, tjs_int x, tjs_int y) = 0;

	//! @brief		(Window->DrawDevice) ͏Ԃ̃`FbN
	//! @note		EBhE1bɁAC}l[W[U̓͂̏Ԃ
	//!				ă`FbN邽߂ɌĂ΂BCԂ̕ω[U̓͂Ƃ
	//!				񓯊ɍsꂽꍇAƂ΃}EXJ[\̉ɃCo
	//!				̂ɂ炸A}EXJ[\̃C̎w肷`ɕύXȂ
	//!				Ƃ󋵂B̂悤ȏ󋵂ɑΏ邽߁AEBhE
	//!				̃\bh1bɌĂ΂B
	virtual void TJS_INTF_METHOD RecheckInputState() = 0;

	//! @brief		(LayerManagerDrawDevice) }EXJ[\̌`ftHgɖ߂
	//! @param		manager		C}l[W
	//! @note		}EXJ[\̌`ftHg̕ɖ߂ꍇɌĂ΂
	virtual void TJS_INTF_METHOD SetDefaultMouseCursor(iTVPLayerManager * manager) = 0;

	//! @brief		(LayerManagerDrawDevice) }EXJ[\̌`ݒ肷
	//! @param		manager		C}l[W
	//! @param		cursor		}EXJ[\`ԍ
	virtual void TJS_INTF_METHOD SetMouseCursor(iTVPLayerManager * manager, tjs_int cursor) = 0;

	//! @brief		(LayerManagerDrawDevice) }EXJ[\̈ʒu擾
	//! @param		manager		C}l[W
	//! @param		x			vC}C̍Wɂ}EXJ[\xʒu
	//! @param		y			vC}C̍Wɂ}EXJ[\yʒu
	//! @note		W̓vC}C̍WȂ̂ŁAKvȂΕϊs
	virtual void TJS_INTF_METHOD GetCursorPos(iTVPLayerManager * manager, tjs_int &x, tjs_int &y) = 0;

	//! @brief		(LayerManagerDrawDevice) }EXJ[\̈ʒuݒ肷
	//! @param		manager		C}l[W
	//! @param		x			vC}C̍Wɂ}EXJ[\xʒu
	//! @param		y			vC}C̍Wɂ}EXJ[\yʒu
	//! @note		W̓vC}C̍WȂ̂ŁAKvȂΕϊs
	virtual void TJS_INTF_METHOD SetCursorPos(iTVPLayerManager * manager, tjs_int x, tjs_int y) = 0;

	//! @brief		(LayerManagerDrawDevice) EBhẼ}EXLv`
	//! @param		manager		C}l[W
	//! @note		EBhẼ}EXLv`ׂꍇɃC}l[WĂ΂B
	//! @note		EBhẼ}EXLv` OnReleaseCapture() ŊJł郌C̃}EXLv`
	//!				ƈقȂ邱ƂɒӁBEBhẼ}EXLv`͎OS̃EBhEVXe
	//!				@\ł邪AC̃}EXLv`͋ggC}l[WƂ
	//!				ƎɊǗĂ镨łB̃\bhł͊{Iɂ ::ReleaseCapture() Ȃǂ
	//!				}EX̃Lv`JB
	virtual void TJS_INTF_METHOD WindowReleaseCapture(iTVPLayerManager * manager) = 0;

	//! @brief		(LayerManagerDrawDevice) c[`bvqgݒ肷
	//! @param		manager		C}l[W
	//! @param		text		qgeLXg(󕶎̏ꍇ̓qg̕\LZ)
	virtual void TJS_INTF_METHOD SetHintText(iTVPLayerManager * manager, const ttstr & text) = 0;

	//! @brief		(LayerManagerDrawDevice) |Cg̐ݒ
	//! @param		manager		C}l[W
	//! @param		layer		tHg̊܂܂郌C
	//! @param		x			vC}C̍Wɂ钍|Cgxʒu
	//! @param		y			vC}C̍Wɂ钍|Cgyʒu
	//! @note		|Cg͒ʏLbgʒûƂŁAIMẼR|WbgEEBhE
	//!				\ꂽA[U⏕̊g勾g債肷BIMER|WbgEBhE
	//!				\Am̕ɕ\肷ۂ̃tHg layer p[^
	//!				Ŏ郌Cɂ邪AvOC炻̏𓾂ݒ肵
	//!				C^[tF[X͍̂ƂȂB
	//! @note		W̓vC}C̍WȂ̂ŁAKvȂΕϊsB
	virtual void TJS_INTF_METHOD SetAttentionPoint(iTVPLayerManager * manager, tTJSNI_BaseLayer *layer,
							tjs_int l, tjs_int t) = 0;

	//! @brief		(LayerManagerDrawDevice) |Cg̉
	//! @param		manager		C}l[W
	virtual void TJS_INTF_METHOD DisableAttentionPoint(iTVPLayerManager * manager) = 0;

	//! @brief		(LayerManagerDrawDevice) IME[h̐ݒ
	//! @param		manager		C}l[W
	//! @param		mode		IME[h
	virtual void TJS_INTF_METHOD SetImeMode(iTVPLayerManager * manager, tTVPImeMode mode) = 0;

	//! @brief		(LayerManagerDrawDevice) IME[h̃Zbg
	//! @param		manager		C}l[W
	virtual void TJS_INTF_METHOD ResetImeMode(iTVPLayerManager * manager) = 0;

//---- vC}C֘A
	//! @brief		(WindowDrawDevice) vC}C̎擾
	//! @return		vC}C
	//! @note		Window.primaryLayer ǂݏoꂽۂɂ̃\bhĂ΂B
	//!				ȊOɌĂ΂邱Ƃ͂ȂB
	virtual tTJSNI_BaseLayer * TJS_INTF_METHOD GetPrimaryLayer() = 0;

	//! @brief		(WindowDrawDevice) tH[JX̂郌C̎擾
	//! @return		tH[JX̂郌C(NULL=tH[JX̂郌CȂꍇ)
	//! @note		Window.focusedLayer ǂݏoꂽۂɂ̃\bhĂ΂B
	//!				ȊOɌĂ΂邱Ƃ͂ȂB
	virtual tTJSNI_BaseLayer * TJS_INTF_METHOD GetFocusedLayer() = 0;

	//! @brief		(WindowDrawDevice) tH[JX̂郌C̐ݒ
	//! @param		layer		tH[JX̂郌C(NULL=tH[JX̂郌CȂԂɂꍇ)
	//! @note		Window.focusedLayer ܂ꂽۂɂ̃\bhĂ΂B
	//!				ȊOɌĂ΂邱Ƃ͂ȂB
	virtual void TJS_INTF_METHOD SetFocusedLayer(tTJSNI_BaseLayer * layer) = 0;


//---- ĕ`֘A
	//! @brief		(WindowDrawDevice) ``̖̒ʒm
	//! @param		rect		``̍WɂAɂȂ̈
	//!							(``̍オ_)
	//! @note		``̈ꕔ邢͑SɂȂۂɃEBhEʒmB
	//!				`foCX́AȂׂɖɂȂĕ`悷ׂłB
	virtual void TJS_INTF_METHOD RequestInvalidation(const tTVPRect & rect) = 0;

	//! @brief		(WindowDrawDevice) XV̗v
	//! @note		``̓eŐV̏ԂɍXVׂ^C~OŁAEBhEĂ΂B
	//!				iTVPWindow::RequestUpdate() Ă񂾌AVXe`^C~Oɓۂ
	//!				Ă΂BʏA`foCX͂̃^C~O𗘗păItXN[
	//!				T[tF[Xɉ摜`悷B
	virtual void TJS_INTF_METHOD Update() = 0;

	//! @brief		(Window->DrawDevice) 摜̕\
	//! @note		ItXN[T[tF[Xɕ`悳ꂽ摜AIXN[ɕ\
	//!				(邢̓tbv) ^C~OŌĂ΂Bʏ Update ̒
	//!				Ă΂邪AVSync ҂LɂȂĂꍇ Update ł͂ȂA
	//!				VBlank ɌĂ΂\BItXN[T[tF[X
	//!				gȂꍇ͖Ă܂ȂB
	virtual void TJS_INTF_METHOD Show() = 0;

//---- LayerManager ̉摜󂯓n֘A
	//! @brief		(LayerManager->DrawDevice) rbg}bv̕`Jn
	//! @param		manager		`Jn郌C}l[W
	//! @note		C}l[W`foCX։摜]OɌĂ΂B
	//!				̂ƁANotifyBitmapCompleted() Cӂ̉񐔌Ă΂AŌ
	//!				EndBitmapCompletion() Ă΂B
	//!				KvȂ΁Ã^C~Oŕ`foCXŃT[tF[X̃bNȂǂ
	//!				sƁB
	virtual void TJS_INTF_METHOD StartBitmapCompletion(iTVPLayerManager * manager) = 0;

	//! @brief		(LayerManager->DrawDevice) rbg}bv̕`ʒm
	//! @param		manager		摜̒񋟌̃C}l[W
	//! @param		x			vC}C̍Wɂ摜̍[ʒu
	//! @param		y			vC}C̍Wɂ摜̏[ʒu
	//! @param		bits		rbg}bvf[^
	//! @param		bitmapinfo	rbg}bv̌`
	//! @param		cliprect	bits ̂Aǂ̕gė~̏
	//! @param		type		񋟂摜z肷鍇[h
	//! @param		opacity		񋟂摜z肷sx(0`255)
	//! @note		C}l[WAʂ`foCXɕ`悵Ă炢ۂ
	//!				Ă΂B̍XV̋`ō\ꍇ邽߁Ã\bh
	//!				StartBitmapCompletion()  EndBitmapCompletion() ̊ԂɕĂ΂\B
	//!				{Iɂ́Abits  bitmapinfo ŕ\rbg}bv̂Acliprect 
	//!				` x, y ʒuɓ]΂悢A``̑傫ɍ킹
	//!				gkȂǂ͕`foCXŖʓ|KvB
	virtual void TJS_INTF_METHOD NotifyBitmapCompleted(iTVPLayerManager * manager,
		tjs_int x, tjs_int y, const void * bits, const BITMAPINFO * bitmapinfo,
		const tTVPRect &cliprect, tTVPLayerType type, tjs_int opacity) = 0;

	//! @brief		(LayerManager->DrawDevice) rbg}bv̕`I
	//! @param		manager		`I郌C}l[W
	virtual void TJS_INTF_METHOD EndBitmapCompletion(iTVPLayerManager * manager) = 0;

//---- fobOx
	//! @brief		(Window->DrawDevice) C\R\[Ƀ_v
	virtual void TJS_INTF_METHOD DumpLayerStructure() = 0;

	//! @brief		(Window->DrawDevice) XV`̕\sǂݒ肷
	//! @param		b		\sǂ
	//! @note		C\@\XVsۂ̋`\A
	//!				XV̍œKɖ𗧂Ă邽߂̎x@\B
	//!				Kv͂ȂA邱Ƃ]܂B
	virtual void TJS_INTF_METHOD SetShowUpdateRect(bool b) = 0;
};
//---------------------------------------------------------------------------
/*]*/

//---------------------------------------------------------------------------
//! @brief		`foCXC^[tF[X̊{IȎ
//---------------------------------------------------------------------------
class tTVPDrawDevice : public iTVPDrawDevice
{
protected:
	iTVPWindow * Window;
	size_t PrimaryLayerManagerIndex; //!< vC}C}l[W
	std::vector<iTVPLayerManager *> Managers; //!< C}l[W̔z
	tTVPRect DestRect; //!< `ʒu

protected:
	tTVPDrawDevice(); //!< RXgN^
protected:
	virtual ~tTVPDrawDevice(); //!< fXgN^

public:
	//! @brief		wʒuɂ郌C}l[W𓾂
	//! @param		index		CfbNX(0`)
	//! @return		wʒuɂ郌C}l[W(AddRefȂ̂Œ)B
	//!				wʒuɃC}l[WȂNULLԂ
	iTVPLayerManager * GetLayerManagerAt(size_t index)
	{
		if(Managers.size() <= index) return NULL;
		return Managers[index];
	}

	//! @brief		DeviceLayerManager̍W̕ϊs
	//! @param		x		Xʒu
	//! @param		y		Yʒu
	//! @return		ϊɐΐ^BȂ΋UBPrimaryLayerManagerIndexɊY
	//!				C}l[WȂ΋UԂ
	//! @note		x, y  DestRect (0,0) _ƂWƂēnƌȂ
	bool TransformToPrimaryLayerManager(tjs_int &x, tjs_int &y);

	//! @brief		LayerManagerDevice̍W̕ϊs
	//! @param		x		Xʒu
	//! @param		y		Yʒu
	//! @return		ϊɐΐ^BȂ΋UBPrimaryLayerManagerIndexɊY
	//!				C}l[WȂ΋UԂ
	//! @note		x, y  C (0,0) _ƂWƂēnƌȂ
	bool TransformFromPrimaryLayerManager(tjs_int &x, tjs_int &y);

//---- IuWFNgԐ
	virtual void TJS_INTF_METHOD Destruct();

//---- window interface ֘A
	virtual void TJS_INTF_METHOD SetWindowInterface(iTVPWindow * window);

//---- LayerManager ̊Ǘ֘A
	virtual void TJS_INTF_METHOD AddLayerManager(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD RemoveLayerManager(iTVPLayerManager * manager);

//---- `ʒuETCY֘A
	virtual void TJS_INTF_METHOD SetDestRectangle(const tTVPRect & rect);
	virtual void TJS_INTF_METHOD GetSrcSize(tjs_int &w, tjs_int &h);
	virtual void TJS_INTF_METHOD NotifyLayerResize(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD NotifyLayerImageChange(iTVPLayerManager * manager);

//---- [U[C^[tF[X֘A
	// window  drawdevice
	virtual void TJS_INTF_METHOD OnClick(tjs_int x, tjs_int y);
	virtual void TJS_INTF_METHOD OnDoubleClick(tjs_int x, tjs_int y);
	virtual void TJS_INTF_METHOD OnMouseDown(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseUp(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseMove(tjs_int x, tjs_int y, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnReleaseCapture();
	virtual void TJS_INTF_METHOD OnMouseOutOfWindow();
	virtual void TJS_INTF_METHOD OnKeyDown(tjs_uint key, tjs_uint32 shift);
	virtual void TJS_INTF_METHOD OnKeyUp(tjs_uint key, tjs_uint32 shift);
	virtual void TJS_INTF_METHOD OnKeyPress(tjs_char key);
	virtual void TJS_INTF_METHOD OnMouseWheel(tjs_uint32 shift, tjs_int delta, tjs_int x, tjs_int y);
	virtual void TJS_INTF_METHOD RecheckInputState();

	// layer manager  drawdevice
	virtual void TJS_INTF_METHOD SetDefaultMouseCursor(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD SetMouseCursor(iTVPLayerManager * manager, tjs_int cursor);
	virtual void TJS_INTF_METHOD GetCursorPos(iTVPLayerManager * manager, tjs_int &x, tjs_int &y);
	virtual void TJS_INTF_METHOD SetCursorPos(iTVPLayerManager * manager, tjs_int x, tjs_int y);
	virtual void TJS_INTF_METHOD SetHintText(iTVPLayerManager * manager, const ttstr & text);
	virtual void TJS_INTF_METHOD WindowReleaseCapture(iTVPLayerManager * manager);

	virtual void TJS_INTF_METHOD SetAttentionPoint(iTVPLayerManager * manager, tTJSNI_BaseLayer *layer,
							tjs_int l, tjs_int t);
	virtual void TJS_INTF_METHOD DisableAttentionPoint(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD SetImeMode(iTVPLayerManager * manager, tTVPImeMode mode);
	virtual void TJS_INTF_METHOD ResetImeMode(iTVPLayerManager * manager);

//---- vC}C֘A
	virtual tTJSNI_BaseLayer * TJS_INTF_METHOD GetPrimaryLayer();
	virtual tTJSNI_BaseLayer * TJS_INTF_METHOD GetFocusedLayer();
	virtual void TJS_INTF_METHOD SetFocusedLayer(tTJSNI_BaseLayer * layer);

//---- ĕ`֘A
	virtual void TJS_INTF_METHOD RequestInvalidation(const tTVPRect & rect);
	virtual void TJS_INTF_METHOD Update();
	virtual void TJS_INTF_METHOD Show() = 0;

//---- fobOx
	virtual void TJS_INTF_METHOD DumpLayerStructure();
	virtual void TJS_INTF_METHOD SetShowUpdateRect(bool b);

// ق̃\bhɂĂ͎Ȃ
};
//---------------------------------------------------------------------------
#endif
