#ifndef IRRLICHTDRAWDEVICE_H
#define IRRLICHTDRAWDEVICE_H

#include <windows.h>
#include "tp_stub.h"
#include <irrlicht.h>

#include "BasicDrawDevice.h"

/**
 * Irrlicht x[X DrawDevice
 */
class tTVPIrrlichtDrawDevice : public tTVPDrawDevice,
							   public tTVPContinuousEventCallbackIntf,
							   public irr::IEventReceiver
{
	typedef tTVPDrawDevice inherited;

protected:
	/// foCX
	irr::IrrlichtDevice *device;
	// hCo
	irr::video::IVideoDriver *driver;
	
public:
	tTVPIrrlichtDrawDevice(); //!< RXgN^
	virtual ~tTVPIrrlichtDrawDevice(); //!< fXgN^

private:
	// eNX`̊蓖
	void allocInfo(iTVPLayerManager * manager);
	// eNX`̉
	void freeInfo(iTVPLayerManager * manager);
	
	void attach(HWND hwnd);
	void detach();

	// Irrlicht ɃCxg𑗂
	bool postEvent(irr::SEvent &ev);
	
public:
	//---- LayerManager ̊Ǘ֘A
	virtual void TJS_INTF_METHOD AddLayerManager(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD RemoveLayerManager(iTVPLayerManager * manager);

	//---- `ʒuETCY֘A
	virtual void TJS_INTF_METHOD SetTargetWindow(HWND wnd, bool is_main);

//---- ĕ`֘A
	virtual void TJS_INTF_METHOD Show();
	
	//---- [U[C^[tF[X֘A
	// window  drawdevice
	virtual void TJS_INTF_METHOD OnMouseDown(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseUp(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseMove(tjs_int x, tjs_int y, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnKeyDown(tjs_uint key, tjs_uint32 shift);
	virtual void TJS_INTF_METHOD OnKeyUp(tjs_uint key, tjs_uint32 shift);
	virtual void TJS_INTF_METHOD OnKeyPress(tjs_char key);
	virtual void TJS_INTF_METHOD OnMouseWheel(tjs_uint32 shift, tjs_int delta, tjs_int x, tjs_int y);
	
	//---- LayerManager ̉摜󂯓n֘A
	virtual void TJS_INTF_METHOD StartBitmapCompletion(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD NotifyBitmapCompleted(iTVPLayerManager * manager,
		tjs_int x, tjs_int y, const void * bits, const BITMAPINFO * bitmapinfo,
		const tTVPRect &cliprect, tTVPLayerType type, tjs_int opacity);
	virtual void TJS_INTF_METHOD EndBitmapCompletion(iTVPLayerManager * manager);

	// ------------------------------------------------------------
	// gǧĂяop
	// ------------------------------------------------------------
public:
	/**
	 * Irrlicht ĂяoJn
	 */
	void start();

	/**
	 * Irrlicht Ăяof
	 */
	void stop();

	/**
	 * Continuous R[obN
	 * ggɂȂƂɏɌĂ΂
	 * h蒼
	 */
	virtual void TJS_INTF_METHOD OnContinuousCallback(tjs_uint64 tick);

	/**
	 * @return foCX
	 */
	tjs_int64 GetDevice() {
		return reinterpret_cast<tjs_int64>((tTVPDrawDevice*)this);
	}
	
	// ------------------------------------------------------------
	// Irrlicht Cxgp
	// ------------------------------------------------------------
public:
	/**
	 * Cxg
	 * GUI Environment ̃CxgɑĂ
	 * @param event Cxg
	 * @return  true
	 */
	virtual bool OnEvent(const irr::SEvent &event);

	// ------------------------------------------------------------
	// V[
	// ------------------------------------------------------------

	/**
	 * V[̓ǂݍ
	 */
	//void loadScene(const char *name);

	/**
	 * JV[̐ݒ
	 */
	//void addCameraSceneNode(int no, irr::core::vector3df *a, irr::core::vector3df *b);
};

#endif
