#include <windows.h>
#include <tchar.h>
#include "ncbind/ncbind.hpp"
#include <map>
using namespace std;

// gg̃EChENX
#define KRWINDOWCLASS _T("TTVPWindowForm")
#define KEYSIZE 256

// -------------------------------------------------------------------
// Ag
// -------------------------------------------------------------------

// mۂAg
static map<ttstr,ATOM> *atoms = NULL;

// OVXeO[oAg擾
static ATOM getAtom(const TCHAR *str)
{
	ttstr name(str);
	map<ttstr,ATOM>::const_iterator n = atoms->find(name);
	if (n != atoms->end()) {
		return n->second;
	}
	ATOM atom = GlobalAddAtom(str);
	(*atoms)[name] = atom;
	return atom;
}

// Ag疼O擾
static void getKey(tTJSVariant &key, ATOM atom)
{
	TCHAR buf[KEYSIZE+1];
	UINT len = GlobalGetAtomName(atom, buf, KEYSIZE);
	if (len > 0) {
		buf[len] = '\0';
		key = buf;
	}
}

// -------------------------------------------------------------------
// {
// -------------------------------------------------------------------

/**
 * \bhǉpNX
 */
class WindowMsg {

protected:
	iTJSDispatch2 *objthis; //< IuWFNg̎Q
	bool messageEnable;     //< bZ[WLǂ

	// --------------------------------------------------------

	typedef bool (__stdcall *NativeReceiver)(iTJSDispatch2 *obj, void *userdata, tTVPWindowMessage *Message);
	
	// [U`V[o
	struct ReceiverInfo {
		NativeReceiver receiverNative;
		iTJSDispatch2 *receiverFunc;
		ttstr receiverStr;
		tTJSVariant userData;
		// ftHgRXgN^
		ReceiverInfo() : receiverNative(NULL), receiverFunc(NULL) {
		};
		// RXgN^
		ReceiverInfo(tTJSVariant &receiver, tTJSVariant &userData)
			: receiverNative(NULL), receiverFunc(NULL), userData(userData) {
				switch (receiver.Type()) {
				case tvtObject:
					receiverFunc = receiver.AsObject();
					receiverFunc->AddRef();
					break;
				case tvtString:
					receiverStr = receiver.GetString();
					break;
				case tvtInteger:
					receiverNative = (NativeReceiver)(tjs_int)receiver;
					break;
				}
			}

		// Rs[RXgN^
		ReceiverInfo(const ReceiverInfo &orig) {
			receiverNative = orig.receiverNative;
			receiverFunc   = orig.receiverFunc;
			receiverStr    = orig.receiverStr;
			if (receiverFunc) {
				receiverFunc->AddRef();
			}
		}

		// fXgN^
		~ReceiverInfo() {
			if (receiverFunc) {
				receiverFunc->Release();
			}
		}

		// ̎s
		bool exec(iTJSDispatch2 *obj, tTVPWindowMessage *message) {
			if (receiverNative) {
				return receiverNative(obj, (void*)(tjs_int)userData, message);
			} else if (receiverFunc) {
				tTJSVariant result;
				tTJSVariant wparam = (tjs_int)message->WParam;
				tTJSVariant lparam = (tjs_int)message->LParam;
				tTJSVariant *p[] = {&userData, &wparam, &lparam};
				receiverFunc->FuncCall(0, NULL, NULL, &result, 3, p, NULL);
				return (int)result != 0;
			} else if (receiverStr != "") {
				tTJSVariant result;
				tTJSVariant wparam = (tjs_int)message->WParam;
				tTJSVariant lparam = (tjs_int)message->LParam;
				tTJSVariant *p[] = {&userData, &wparam, &lparam};
				obj->FuncCall(0, receiverStr.c_str(), NULL, &result, 3, p, obj);
				return (int)result != 0;
			}
			return false;
		}
	};
	
	map<unsigned int, ReceiverInfo> receiverMap;

	// [UK背V[o̍폜
	void removeUserReceiver(unsigned int Msg) {
		map<unsigned int, ReceiverInfo>::const_iterator n = receiverMap.find(Msg);
		if (n != receiverMap.end()) {
			receiverMap.erase(Msg);
		}
	}
	
	// [UK背V[o̓o^
	void addUserReceiver(unsigned int Msg, tTJSVariant &receiver, tTJSVariant &userdata) {
		removeUserReceiver(Msg);
		receiverMap[Msg] = ReceiverInfo(receiver, userdata);
	}

	// --------------------------------------------------------

	ttstr storeKey;         //< HWND ۑwL[
	
	/**
	 * st@Cꏊ HWND ۑ
	 */
	void storeHWND(HWND hwnd) {
		if (storeKey != "") {
			tTJSVariant varScripts;
			TVPExecuteExpression(TJS_W("System.exeName"), &varScripts);
			ttstr path = varScripts;
			path += ".";
			path += storeKey;
			IStream *stream = TVPCreateIStream(path, TJS_BS_WRITE);
			if (stream != NULL) {
				char buf[100];
				DWORD len;
				_snprintf(buf, sizeof buf, "%d", (int)hwnd);
				stream->Write(buf, strlen(buf), &len);
				stream->Release();
			}
		}
	}
	
	/**
	 * bZ[WM֐{
	 * @param userdata [Uf[^(̏ꍇlCeBuIuWFNg)
	 * @param Message EChEbZ[W
	 */
	static bool __stdcall MyReceiver(void *userdata, tTVPWindowMessage *Message) {

		iTJSDispatch2 *obj = (iTJSDispatch2*)userdata; // Window ̃IuWFNg
		// gg̓̊֌WŃCxg͓o^jłĂ΂邱Ƃ̂
		// Window ̖{̃IuWFNglCeBuIuWFNg蒼
		WindowMsg *self = ncbInstanceAdaptor<WindowMsg>::GetNativeInstance(obj);
		if (self == NULL) {
			return false;
		}
		switch (Message->Msg) {
		case TVP_WM_DETACH: // EChE؂藣ꂽ
			break; 
		case TVP_WM_ATTACH: // EChEݒ肳ꂽ
			self->storeHWND((HWND)Message->LParam);
			break;
		case WM_COPYDATA: // O̒ʐM
			{
				COPYDATASTRUCT *copyData = (COPYDATASTRUCT*)Message->LParam;
				tTJSVariant key;
				getKey(key, (ATOM)copyData->dwData);
				tTJSVariant msg((const tjs_char *)copyData->lpData);
				tTJSVariant *p[] = {&key, &msg};
				obj->FuncCall(0, L"onMessageReceived", NULL, NULL, 2, p, obj);
			}
			return true;
		default:
			{
				map<unsigned int, ReceiverInfo>::iterator n = self->receiverMap.find(Message->Msg);
				if (n != self->receiverMap.end()) {
					return n->second.exec(obj, Message);
				}
			}
			break;
		}
		return false;
	}

	void doStoreKey() {
		if (storeKey != "") {
			tTJSVariant val;
			objthis->PropGet(0, TJS_W("HWND"), NULL, &val, objthis);
			storeHWND(reinterpret_cast<HWND>((tjs_int)(val)));
		}
	}
	
	/**
	 * V[o̓o^
	 */
	void registReceiver(bool enable) {
		// V[oXV
		tTJSVariant mode    = enable ? (tTVInteger)(tjs_int)wrmRegister : (tTVInteger)(tjs_int)wrmUnregister;
		tTJSVariant proc     = (tTVInteger)(tjs_int)MyReceiver;
		tTJSVariant userdata = (tTVInteger)(tjs_int)objthis;
		tTJSVariant *p[3] = {&mode, &proc, &userdata};
		int ret = objthis->FuncCall(0, L"registerMessageReceiver", NULL, NULL, 3, p, objthis);
	}

public:
	// RXgN^
	WindowMsg(iTJSDispatch2 *objthis) : objthis(objthis), messageEnable(false) {}

	// fXgN^
	~WindowMsg() {
		receiverMap.clear();
		// V[o
		registReceiver(false);
	}

	/**
	 * bZ[WMLǂݒ
	 * @param enable true ȂL
	 */
	void setMessageEnable(bool enable) {
		if (messageEnable != enable) {
			messageEnable = enable;
			registReceiver(messageEnable);
			if (messageEnable) {
				doStoreKey();
			}
		}
	}
	
	/**
	 * @return bZ[WMLǂ擾
	 */
	bool getMessageEnable() {
		return messageEnable;
	}

	/**
	 * storeKey w
	 * ̒lw肷ƁAHWND ̒l st@C.key Ƃĕۑ悤ɂȂ܂
	 * @param keyName HWNDۑpL[
	 */
	void setStoreKey(const tjs_char *keyName) {
		if (storeKey != keyName) {
			storeKey = keyName;
			if (messageEnable) {
				doStoreKey();
			}
		}
	}

	/**
	 * @return storeKey 擾
	 */
	const tjs_char *getStoreKey() {
		return storeKey.c_str();
	}

	/**
	 * OvOC̃bZ[WWbN̓o^
	 * @param mode o^[h
	 * @param msg
	 * @param func
	 */
	static tjs_error TJS_INTF_METHOD registerUserMessageReceiver(tTJSVariant *result,
																 tjs_int numparams,
																 tTJSVariant **param,
																 WindowMsg *self) {
		if (numparams < 2) return TJS_E_BADPARAMCOUNT;
		int mode         = (tjs_int)*param[0];
		unsigned int msg;
		if (param[1]->Type() == tvtString) {
			msg = RegisterWindowMessage(param[1]->GetString());
		} else {
			msg = (unsigned int)(tTVInteger)*param[1];
		}
		if (mode == wrmRegister) {
			if (numparams < 4) return TJS_E_BADPARAMCOUNT;
			self->addUserReceiver(msg, *param[2], *param[3]);
		} else if (mode == wrmUnregister) {
			self->removeUserReceiver(msg);
		}
		if (result) {
			*result = (tjs_int)msg;
		}
		return TJS_S_OK;
	}

	// MbZ[W
	struct UserMsgInfo {
		HWND hWnd;
		unsigned int msg;
		WPARAM wparam;
		LPARAM lparam;
		UserMsgInfo(HWND hWnd, unsigned int msg, WPARAM wparam, LPARAM lparam) : hWnd(hWnd), msg(msg), wparam(wparam), lparam(lparam) {}
	};

	/**
	 * ʑւ̃bZ[WM
	 * @param hWnd MEChEnh
	 * @param parent M
	 */
	static BOOL CALLBACK enumWindowsProcUser(HWND hWnd, LPARAM parent) {
		UserMsgInfo *info = (UserMsgInfo*)parent;
		TCHAR buf[100];
		GetClassName(hWnd, buf, sizeof buf);
		if (info->hWnd != hWnd && _tcscmp(buf, KRWINDOWCLASS) == 0) {
			SendMessage(hWnd, info->msg, info->wparam, info->lparam);
		}
		return TRUE;
	}
	
	/**
	 * [U`bZ[WM
	 * NĂggׂĂɃbZ[W𑗐M܂
	 * @param msg bZ[WID
	 * @param wparam WPARAMl
	 * @param lparam LPARAMl
	 */
	void sendUserMessage(unsigned int msg, tjs_int wparam, tjs_int lparam) {
		tTJSVariant val;
		objthis->PropGet(0, TJS_W("HWND"), NULL, &val, objthis);
		UserMsgInfo info(reinterpret_cast<HWND>((tjs_int)(val)), msg, (WPARAM)wparam, (LPARAM)lparam);
		EnumWindows(enumWindowsProcUser, (LPARAM)&info);
	}
	
	// --------------------------------------------------------
	
	// MbZ[W
	struct MsgInfo {
		HWND hWnd;
		COPYDATASTRUCT copyData;
		MsgInfo(HWND hWnd, const TCHAR *key, const tjs_char *msg) : hWnd(hWnd) {
			copyData.dwData = getAtom(key);
			copyData.cbData = (TJS_strlen(msg) + 1) * sizeof(tjs_char);
			copyData.lpData = (PVOID)msg;
		}
	};

	/**
	 * ʑւ̃bZ[WM
	 * @param hWnd MEChEnh
	 * @param parent M
	 */
	static BOOL CALLBACK enumWindowsProc(HWND hWnd, LPARAM parent) {
		MsgInfo *info = (MsgInfo*)parent;
		TCHAR buf[100];
		GetClassName(hWnd, buf, sizeof buf);
		if (info->hWnd != hWnd && _tcscmp(buf, KRWINDOWCLASS) == 0) {
			SendMessage(hWnd, WM_COPYDATA, (WPARAM)info->hWnd, (LPARAM)&info->copyData);
		}
		return TRUE;
	}

	/**
	 * bZ[WM
	 * NĂggׂĂɃbZ[W𑗐M܂
	 * @param key ʃL[
	 * @param msg bZ[W
	 */
	void sendMessage(const TCHAR *key, const tjs_char *msg) {
		tTJSVariant val;
		objthis->PropGet(0, TJS_W("HWND"), NULL, &val, objthis);
		MsgInfo info(reinterpret_cast<HWND>((tjs_int)(val)), key, msg);
		EnumWindows(enumWindowsProc, (LPARAM)&info);
	}

};

// CX^XQb^
NCB_GET_INSTANCE_HOOK(WindowMsg)
{
	NCB_INSTANCE_GETTER(objthis) { // objthis  iTJSDispatch2* ^̈Ƃ
		ClassT* obj = GetNativeInstance(objthis);	// lCeBuCX^X|C^擾
		if (!obj) {
			obj = new ClassT(objthis);				// Ȃꍇ͐
			SetNativeInstance(objthis, obj);		// objthis  obj lCeBuCX^XƂēo^
		}
		return obj;
	}
};

// tbNA^b`
NCB_ATTACH_CLASS_WITH_HOOK(WindowMsg, Window) {
	Property(L"messageEnable", &WindowMsg::getMessageEnable, &WindowMsg::setMessageEnable);
	Property(L"storeHWND", &WindowMsg::getStoreKey, &WindowMsg::setStoreKey);
	RawCallback("registerUserMessageReceiver", &WindowMsg::registerUserMessageReceiver, 0);
	Method(L"sendUserMessage", &WindowMsg::sendUserMessage);
	Method(L"sendMessage", &WindowMsg::sendMessage);
}

/**
 * o^O
 */
void PreRegistCallback()
{
	atoms = new map<ttstr,ATOM>;
}

/**
 * J
 */
void PostUnregistCallback()
{
	map<ttstr,ATOM>::const_iterator i = atoms->begin();
	while (i != atoms->end()) {
		GlobalDeleteAtom(i->second);
		i++;
	}
	delete atoms;
	atoms = NULL;
}

NCB_PRE_REGIST_CALLBACK(PreRegistCallback);
NCB_POST_UNREGIST_CALLBACK(PostUnregistCallback);
